function Hz = rad_s2Hz(rad_s)
%
%   syntax:
%    Hz = rad_s2Hz(rad_s)
%
%   Input:
%   rad_s   : radians per second
%   
%   Output:
%   Hz      : Revolutions per second
%
%   Authors:    Kostas Alexis (konstantinos.alexis@mavt.ethz.ch)

Hz = rad_s/(2*pi);
end