/* Include files */

#include "blascompat32.h"
#include "ACX_Simulator_sfun.h"
#include "c28_ACX_Simulator.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ACX_Simulator_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c28_debug_family_names[8] = { "switch_value", "nargin",
  "nargout", "KpNom", "Kp_GS", "error_value", "DeltaMax", "K_P_G_S" };

/* Function Declarations */
static void initialize_c28_ACX_Simulator(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initialize_params_c28_ACX_Simulator
  (SFc28_ACX_SimulatorInstanceStruct *chartInstance);
static void enable_c28_ACX_Simulator(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance);
static void disable_c28_ACX_Simulator(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance);
static void c28_update_debugger_state_c28_ACX_Simulator
  (SFc28_ACX_SimulatorInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c28_ACX_Simulator
  (SFc28_ACX_SimulatorInstanceStruct *chartInstance);
static void set_sim_state_c28_ACX_Simulator(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c28_st);
static void finalize_c28_ACX_Simulator(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance);
static void sf_c28_ACX_Simulator(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initSimStructsc28_ACX_Simulator(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c28_machineNumber, uint32_T
  c28_chartNumber);
static const mxArray *c28_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData);
static real_T c28_emlrt_marshallIn(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c28_K_P_G_S, const char_T *c28_identifier);
static real_T c28_b_emlrt_marshallIn(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId);
static void c28_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData);
static const mxArray *c28_b_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData);
static const mxArray *c28_c_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData);
static int32_T c28_c_emlrt_marshallIn(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId);
static void c28_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData);
static uint8_T c28_d_emlrt_marshallIn(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c28_b_is_active_c28_ACX_Simulator, const char_T
  *c28_identifier);
static uint8_T c28_e_emlrt_marshallIn(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId);
static void init_dsm_address_info(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c28_ACX_Simulator(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  chartInstance->c28_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c28_is_active_c28_ACX_Simulator = 0U;
}

static void initialize_params_c28_ACX_Simulator
  (SFc28_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static void enable_c28_ACX_Simulator(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c28_ACX_Simulator(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c28_update_debugger_state_c28_ACX_Simulator
  (SFc28_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c28_ACX_Simulator
  (SFc28_ACX_SimulatorInstanceStruct *chartInstance)
{
  const mxArray *c28_st;
  const mxArray *c28_y = NULL;
  real_T c28_hoistedGlobal;
  real_T c28_u;
  const mxArray *c28_b_y = NULL;
  uint8_T c28_b_hoistedGlobal;
  uint8_T c28_b_u;
  const mxArray *c28_c_y = NULL;
  real_T *c28_K_P_G_S;
  c28_K_P_G_S = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c28_st = NULL;
  c28_st = NULL;
  c28_y = NULL;
  sf_mex_assign(&c28_y, sf_mex_createcellarray(2));
  c28_hoistedGlobal = *c28_K_P_G_S;
  c28_u = c28_hoistedGlobal;
  c28_b_y = NULL;
  sf_mex_assign(&c28_b_y, sf_mex_create("y", &c28_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c28_y, 0, c28_b_y);
  c28_b_hoistedGlobal = chartInstance->c28_is_active_c28_ACX_Simulator;
  c28_b_u = c28_b_hoistedGlobal;
  c28_c_y = NULL;
  sf_mex_assign(&c28_c_y, sf_mex_create("y", &c28_b_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c28_y, 1, c28_c_y);
  sf_mex_assign(&c28_st, c28_y);
  return c28_st;
}

static void set_sim_state_c28_ACX_Simulator(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c28_st)
{
  const mxArray *c28_u;
  real_T *c28_K_P_G_S;
  c28_K_P_G_S = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c28_doneDoubleBufferReInit = TRUE;
  c28_u = sf_mex_dup(c28_st);
  *c28_K_P_G_S = c28_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c28_u, 0)), "K_P_G_S");
  chartInstance->c28_is_active_c28_ACX_Simulator = c28_d_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c28_u, 1)),
     "is_active_c28_ACX_Simulator");
  sf_mex_destroy(&c28_u);
  c28_update_debugger_state_c28_ACX_Simulator(chartInstance);
  sf_mex_destroy(&c28_st);
}

static void finalize_c28_ACX_Simulator(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void sf_c28_ACX_Simulator(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  int32_T c28_i0;
  real_T c28_hoistedGlobal;
  real_T c28_b_hoistedGlobal;
  real_T c28_c_hoistedGlobal;
  real_T c28_KpNom;
  int32_T c28_i1;
  real_T c28_Kp_GS[50];
  real_T c28_error_value;
  real_T c28_DeltaMax;
  uint32_T c28_debug_family_var_map[8];
  real_T c28_switch_value;
  real_T c28_nargin = 4.0;
  real_T c28_nargout = 1.0;
  real_T c28_K_P_G_S;
  real_T c28_x;
  real_T c28_b_x;
  real_T c28_a;
  real_T c28_y;
  real_T c28_A;
  real_T c28_B;
  real_T c28_c_x;
  real_T c28_b_y;
  real_T c28_d_x;
  real_T c28_c_y;
  real_T c28_e_x;
  real_T c28_d_y;
  real_T c28_e_y;
  real_T c28_f_x;
  real_T c28_g_x;
  real_T *c28_b_KpNom;
  real_T *c28_b_K_P_G_S;
  real_T *c28_b_error_value;
  real_T *c28_b_DeltaMax;
  real_T (*c28_b_Kp_GS)[50];
  c28_b_DeltaMax = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c28_b_error_value = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c28_b_Kp_GS = (real_T (*)[50])ssGetInputPortSignal(chartInstance->S, 1);
  c28_b_K_P_G_S = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c28_b_KpNom = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 27U, chartInstance->c28_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c28_b_KpNom, 0U);
  _SFD_DATA_RANGE_CHECK(*c28_b_K_P_G_S, 1U);
  for (c28_i0 = 0; c28_i0 < 50; c28_i0++) {
    _SFD_DATA_RANGE_CHECK((*c28_b_Kp_GS)[c28_i0], 2U);
  }

  _SFD_DATA_RANGE_CHECK(*c28_b_error_value, 3U);
  _SFD_DATA_RANGE_CHECK(*c28_b_DeltaMax, 4U);
  chartInstance->c28_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 27U, chartInstance->c28_sfEvent);
  c28_hoistedGlobal = *c28_b_KpNom;
  c28_b_hoistedGlobal = *c28_b_error_value;
  c28_c_hoistedGlobal = *c28_b_DeltaMax;
  c28_KpNom = c28_hoistedGlobal;
  for (c28_i1 = 0; c28_i1 < 50; c28_i1++) {
    c28_Kp_GS[c28_i1] = (*c28_b_Kp_GS)[c28_i1];
  }

  c28_error_value = c28_b_hoistedGlobal;
  c28_DeltaMax = c28_c_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 8U, 8U, c28_debug_family_names,
    c28_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c28_switch_value, 0U,
    c28_sf_marshallOut, c28_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_nargin, 1U, c28_sf_marshallOut,
    c28_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c28_nargout, 2U, c28_sf_marshallOut,
    c28_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c28_KpNom, 3U, c28_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c28_Kp_GS, 4U, c28_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c28_error_value, 5U, c28_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c28_DeltaMax, 6U, c28_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c28_K_P_G_S, 7U, c28_sf_marshallOut,
    c28_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 4);
  c28_x = c28_error_value;
  c28_b_x = c28_x;
  c28_error_value = muDoubleScalarAbs(c28_b_x);
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 6);
  if (CV_EML_IF(0, 0, c28_error_value >= c28_DeltaMax)) {
    _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 7);
    c28_error_value = c28_DeltaMax;
  }

  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 10);
  c28_a = c28_error_value;
  c28_y = c28_a * 49.0;
  c28_A = c28_y;
  c28_B = c28_DeltaMax;
  c28_c_x = c28_A;
  c28_b_y = c28_B;
  c28_d_x = c28_c_x;
  c28_c_y = c28_b_y;
  c28_e_x = c28_d_x;
  c28_d_y = c28_c_y;
  c28_e_y = c28_e_x / c28_d_y;
  c28_f_x = c28_e_y;
  c28_g_x = c28_f_x;
  c28_g_x = muDoubleScalarFloor(c28_g_x);
  c28_switch_value = c28_g_x + 1.0;
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 12);
  if (CV_EML_IF(0, 1, c28_switch_value >= 50.0)) {
    _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 13);
    c28_switch_value = 50.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, 16);
  c28_K_P_G_S = c28_KpNom - c28_Kp_GS[_SFD_EML_ARRAY_BOUNDS_CHECK("Kp_GS",
    (int32_T)_SFD_INTEGER_CHECK("switch_value", c28_switch_value), 1, 50, 1, 0)
    - 1];
  _SFD_EML_CALL(0U, chartInstance->c28_sfEvent, -16);
  sf_debug_symbol_scope_pop();
  *c28_b_K_P_G_S = c28_K_P_G_S;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 27U, chartInstance->c28_sfEvent);
  sf_debug_check_for_state_inconsistency(_ACX_SimulatorMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc28_ACX_Simulator(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c28_machineNumber, uint32_T
  c28_chartNumber)
{
}

static const mxArray *c28_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData)
{
  const mxArray *c28_mxArrayOutData = NULL;
  real_T c28_u;
  const mxArray *c28_y = NULL;
  SFc28_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc28_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c28_mxArrayOutData = NULL;
  c28_u = *(real_T *)c28_inData;
  c28_y = NULL;
  sf_mex_assign(&c28_y, sf_mex_create("y", &c28_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c28_mxArrayOutData, c28_y);
  return c28_mxArrayOutData;
}

static real_T c28_emlrt_marshallIn(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c28_K_P_G_S, const char_T *c28_identifier)
{
  real_T c28_y;
  emlrtMsgIdentifier c28_thisId;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_y = c28_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c28_K_P_G_S),
    &c28_thisId);
  sf_mex_destroy(&c28_K_P_G_S);
  return c28_y;
}

static real_T c28_b_emlrt_marshallIn(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId)
{
  real_T c28_y;
  real_T c28_d0;
  sf_mex_import(c28_parentId, sf_mex_dup(c28_u), &c28_d0, 1, 0, 0U, 0, 0U, 0);
  c28_y = c28_d0;
  sf_mex_destroy(&c28_u);
  return c28_y;
}

static void c28_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData)
{
  const mxArray *c28_K_P_G_S;
  const char_T *c28_identifier;
  emlrtMsgIdentifier c28_thisId;
  real_T c28_y;
  SFc28_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc28_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c28_K_P_G_S = sf_mex_dup(c28_mxArrayInData);
  c28_identifier = c28_varName;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_y = c28_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c28_K_P_G_S),
    &c28_thisId);
  sf_mex_destroy(&c28_K_P_G_S);
  *(real_T *)c28_outData = c28_y;
  sf_mex_destroy(&c28_mxArrayInData);
}

static const mxArray *c28_b_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData)
{
  const mxArray *c28_mxArrayOutData = NULL;
  int32_T c28_i2;
  real_T c28_b_inData[50];
  int32_T c28_i3;
  real_T c28_u[50];
  const mxArray *c28_y = NULL;
  SFc28_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc28_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c28_mxArrayOutData = NULL;
  for (c28_i2 = 0; c28_i2 < 50; c28_i2++) {
    c28_b_inData[c28_i2] = (*(real_T (*)[50])c28_inData)[c28_i2];
  }

  for (c28_i3 = 0; c28_i3 < 50; c28_i3++) {
    c28_u[c28_i3] = c28_b_inData[c28_i3];
  }

  c28_y = NULL;
  sf_mex_assign(&c28_y, sf_mex_create("y", c28_u, 0, 0U, 1U, 0U, 1, 50));
  sf_mex_assign(&c28_mxArrayOutData, c28_y);
  return c28_mxArrayOutData;
}

const mxArray *sf_c28_ACX_Simulator_get_eml_resolved_functions_info(void)
{
  const mxArray *c28_nameCaptureInfo;
  c28_ResolvedFunctionInfo c28_info[9];
  c28_ResolvedFunctionInfo (*c28_b_info)[9];
  const mxArray *c28_m0 = NULL;
  int32_T c28_i4;
  c28_ResolvedFunctionInfo *c28_r0;
  c28_nameCaptureInfo = NULL;
  c28_nameCaptureInfo = NULL;
  c28_b_info = (c28_ResolvedFunctionInfo (*)[9])c28_info;
  (*c28_b_info)[0].context = "";
  (*c28_b_info)[0].name = "abs";
  (*c28_b_info)[0].dominantType = "double";
  (*c28_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c28_b_info)[0].fileTimeLo = 1286818694U;
  (*c28_b_info)[0].fileTimeHi = 0U;
  (*c28_b_info)[0].mFileTimeLo = 0U;
  (*c28_b_info)[0].mFileTimeHi = 0U;
  (*c28_b_info)[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c28_b_info)[1].name = "eml_scalar_abs";
  (*c28_b_info)[1].dominantType = "double";
  (*c28_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  (*c28_b_info)[1].fileTimeLo = 1286818712U;
  (*c28_b_info)[1].fileTimeHi = 0U;
  (*c28_b_info)[1].mFileTimeLo = 0U;
  (*c28_b_info)[1].mFileTimeHi = 0U;
  (*c28_b_info)[2].context = "";
  (*c28_b_info)[2].name = "length";
  (*c28_b_info)[2].dominantType = "double";
  (*c28_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  (*c28_b_info)[2].fileTimeLo = 1286818760U;
  (*c28_b_info)[2].fileTimeHi = 0U;
  (*c28_b_info)[2].mFileTimeLo = 0U;
  (*c28_b_info)[2].mFileTimeHi = 0U;
  (*c28_b_info)[3].context = "";
  (*c28_b_info)[3].name = "mtimes";
  (*c28_b_info)[3].dominantType = "double";
  (*c28_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c28_b_info)[3].fileTimeLo = 1289519692U;
  (*c28_b_info)[3].fileTimeHi = 0U;
  (*c28_b_info)[3].mFileTimeLo = 0U;
  (*c28_b_info)[3].mFileTimeHi = 0U;
  (*c28_b_info)[4].context = "";
  (*c28_b_info)[4].name = "mrdivide";
  (*c28_b_info)[4].dominantType = "double";
  (*c28_b_info)[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c28_b_info)[4].fileTimeLo = 1296664654U;
  (*c28_b_info)[4].fileTimeHi = 0U;
  (*c28_b_info)[4].mFileTimeLo = 1289519692U;
  (*c28_b_info)[4].mFileTimeHi = 0U;
  (*c28_b_info)[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c28_b_info)[5].name = "rdivide";
  (*c28_b_info)[5].dominantType = "double";
  (*c28_b_info)[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c28_b_info)[5].fileTimeLo = 1286818844U;
  (*c28_b_info)[5].fileTimeHi = 0U;
  (*c28_b_info)[5].mFileTimeLo = 0U;
  (*c28_b_info)[5].mFileTimeHi = 0U;
  (*c28_b_info)[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c28_b_info)[6].name = "eml_div";
  (*c28_b_info)[6].dominantType = "double";
  (*c28_b_info)[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c28_b_info)[6].fileTimeLo = 1286818698U;
  (*c28_b_info)[6].fileTimeHi = 0U;
  (*c28_b_info)[6].mFileTimeLo = 0U;
  (*c28_b_info)[6].mFileTimeHi = 0U;
  (*c28_b_info)[7].context = "";
  (*c28_b_info)[7].name = "floor";
  (*c28_b_info)[7].dominantType = "double";
  (*c28_b_info)[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  (*c28_b_info)[7].fileTimeLo = 1286818742U;
  (*c28_b_info)[7].fileTimeHi = 0U;
  (*c28_b_info)[7].mFileTimeLo = 0U;
  (*c28_b_info)[7].mFileTimeHi = 0U;
  (*c28_b_info)[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  (*c28_b_info)[8].name = "eml_scalar_floor";
  (*c28_b_info)[8].dominantType = "double";
  (*c28_b_info)[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  (*c28_b_info)[8].fileTimeLo = 1286818726U;
  (*c28_b_info)[8].fileTimeHi = 0U;
  (*c28_b_info)[8].mFileTimeLo = 0U;
  (*c28_b_info)[8].mFileTimeHi = 0U;
  sf_mex_assign(&c28_m0, sf_mex_createstruct("nameCaptureInfo", 1, 9));
  for (c28_i4 = 0; c28_i4 < 9; c28_i4++) {
    c28_r0 = &c28_info[c28_i4];
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo", c28_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c28_r0->context)), "context", "nameCaptureInfo",
                    c28_i4);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo", c28_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c28_r0->name)), "name", "nameCaptureInfo", c28_i4);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo",
      c28_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c28_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c28_i4);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo", c28_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c28_r0->resolved)), "resolved",
                    "nameCaptureInfo", c28_i4);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo", &c28_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c28_i4);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo", &c28_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c28_i4);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo",
      &c28_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c28_i4);
    sf_mex_addfield(c28_m0, sf_mex_create("nameCaptureInfo",
      &c28_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c28_i4);
  }

  sf_mex_assign(&c28_nameCaptureInfo, c28_m0);
  return c28_nameCaptureInfo;
}

static const mxArray *c28_c_sf_marshallOut(void *chartInstanceVoid, void
  *c28_inData)
{
  const mxArray *c28_mxArrayOutData = NULL;
  int32_T c28_u;
  const mxArray *c28_y = NULL;
  SFc28_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc28_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c28_mxArrayOutData = NULL;
  c28_u = *(int32_T *)c28_inData;
  c28_y = NULL;
  sf_mex_assign(&c28_y, sf_mex_create("y", &c28_u, 6, 0U, 0U, 0U, 0));
  sf_mex_assign(&c28_mxArrayOutData, c28_y);
  return c28_mxArrayOutData;
}

static int32_T c28_c_emlrt_marshallIn(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId)
{
  int32_T c28_y;
  int32_T c28_i5;
  sf_mex_import(c28_parentId, sf_mex_dup(c28_u), &c28_i5, 1, 6, 0U, 0, 0U, 0);
  c28_y = c28_i5;
  sf_mex_destroy(&c28_u);
  return c28_y;
}

static void c28_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c28_mxArrayInData, const char_T *c28_varName, void *c28_outData)
{
  const mxArray *c28_b_sfEvent;
  const char_T *c28_identifier;
  emlrtMsgIdentifier c28_thisId;
  int32_T c28_y;
  SFc28_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc28_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c28_b_sfEvent = sf_mex_dup(c28_mxArrayInData);
  c28_identifier = c28_varName;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_y = c28_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c28_b_sfEvent),
    &c28_thisId);
  sf_mex_destroy(&c28_b_sfEvent);
  *(int32_T *)c28_outData = c28_y;
  sf_mex_destroy(&c28_mxArrayInData);
}

static uint8_T c28_d_emlrt_marshallIn(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c28_b_is_active_c28_ACX_Simulator, const char_T
  *c28_identifier)
{
  uint8_T c28_y;
  emlrtMsgIdentifier c28_thisId;
  c28_thisId.fIdentifier = c28_identifier;
  c28_thisId.fParent = NULL;
  c28_y = c28_e_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c28_b_is_active_c28_ACX_Simulator), &c28_thisId);
  sf_mex_destroy(&c28_b_is_active_c28_ACX_Simulator);
  return c28_y;
}

static uint8_T c28_e_emlrt_marshallIn(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c28_u, const emlrtMsgIdentifier *c28_parentId)
{
  uint8_T c28_y;
  uint8_T c28_u0;
  sf_mex_import(c28_parentId, sf_mex_dup(c28_u), &c28_u0, 1, 3, 0U, 0, 0U, 0);
  c28_y = c28_u0;
  sf_mex_destroy(&c28_u);
  return c28_y;
}

static void init_dsm_address_info(SFc28_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c28_ACX_Simulator_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(40377782U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3573153763U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2162745194U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(4206778397U);
}

mxArray *sf_c28_ACX_Simulator_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(614111232U);
    pr[1] = (double)(2540218296U);
    pr[2] = (double)(1819036883U);
    pr[3] = (double)(3959128791U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(50);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c28_ACX_Simulator(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"K_P_G_S\",},{M[8],M[0],T\"is_active_c28_ACX_Simulator\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c28_ACX_Simulator_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc28_ACX_SimulatorInstanceStruct *chartInstance;
    chartInstance = (SFc28_ACX_SimulatorInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ACX_SimulatorMachineNumber_,
           28,
           1,
           1,
           5,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_ACX_SimulatorMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"KpNom");
          _SFD_SET_DATA_PROPS(1,2,0,1,"K_P_G_S");
          _SFD_SET_DATA_PROPS(2,1,1,0,"Kp_GS");
          _SFD_SET_DATA_PROPS(3,1,1,0,"error_value");
          _SFD_SET_DATA_PROPS(4,1,1,0,"DeltaMax");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,2,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,355);
        _SFD_CV_INIT_EML_IF(0,0,116,141,-1,173);
        _SFD_CV_INIT_EML_IF(0,1,242,273,-1,311);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_sf_marshallOut,(MexInFcnForType)c28_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 50;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c28_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c28_sf_marshallOut,(MexInFcnForType)NULL);

        {
          real_T *c28_KpNom;
          real_T *c28_K_P_G_S;
          real_T *c28_error_value;
          real_T *c28_DeltaMax;
          real_T (*c28_Kp_GS)[50];
          c28_DeltaMax = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c28_error_value = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c28_Kp_GS = (real_T (*)[50])ssGetInputPortSignal(chartInstance->S, 1);
          c28_K_P_G_S = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c28_KpNom = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c28_KpNom);
          _SFD_SET_DATA_VALUE_PTR(1U, c28_K_P_G_S);
          _SFD_SET_DATA_VALUE_PTR(2U, *c28_Kp_GS);
          _SFD_SET_DATA_VALUE_PTR(3U, c28_error_value);
          _SFD_SET_DATA_VALUE_PTR(4U, c28_DeltaMax);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ACX_SimulatorMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c28_ACX_Simulator(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc28_ACX_SimulatorInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c28_ACX_Simulator((SFc28_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
  initialize_c28_ACX_Simulator((SFc28_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c28_ACX_Simulator(void *chartInstanceVar)
{
  enable_c28_ACX_Simulator((SFc28_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c28_ACX_Simulator(void *chartInstanceVar)
{
  disable_c28_ACX_Simulator((SFc28_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c28_ACX_Simulator(void *chartInstanceVar)
{
  sf_c28_ACX_Simulator((SFc28_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c28_ACX_Simulator(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c28_ACX_Simulator
    ((SFc28_ACX_SimulatorInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c28_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c28_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c28_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c28_ACX_Simulator((SFc28_ACX_SimulatorInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c28_ACX_Simulator(SimStruct* S)
{
  return sf_internal_get_sim_state_c28_ACX_Simulator(S);
}

static void sf_opaque_set_sim_state_c28_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  sf_internal_set_sim_state_c28_ACX_Simulator(S, st);
}

static void sf_opaque_terminate_c28_ACX_Simulator(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc28_ACX_SimulatorInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c28_ACX_Simulator((SFc28_ACX_SimulatorInstanceStruct*)
      chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc28_ACX_Simulator((SFc28_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c28_ACX_Simulator(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c28_ACX_Simulator((SFc28_ACX_SimulatorInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c28_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,"ACX_Simulator","ACX_Simulator",28);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,"ACX_Simulator","ACX_Simulator",28,
                "RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,"ACX_Simulator",
      "ACX_Simulator",28,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"ACX_Simulator","ACX_Simulator",28,4);
      sf_mark_chart_reusable_outputs(S,"ACX_Simulator","ACX_Simulator",28,1);
    }

    sf_set_rtw_dwork_info(S,"ACX_Simulator","ACX_Simulator",28);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1734481975U));
  ssSetChecksum1(S,(1560111855U));
  ssSetChecksum2(S,(3938586764U));
  ssSetChecksum3(S,(113110536U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c28_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "ACX_Simulator", "ACX_Simulator",28);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c28_ACX_Simulator(SimStruct *S)
{
  SFc28_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc28_ACX_SimulatorInstanceStruct *)malloc(sizeof
    (SFc28_ACX_SimulatorInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc28_ACX_SimulatorInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c28_ACX_Simulator;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c28_ACX_Simulator;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c28_ACX_Simulator;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c28_ACX_Simulator;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c28_ACX_Simulator;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c28_ACX_Simulator;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c28_ACX_Simulator;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c28_ACX_Simulator;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c28_ACX_Simulator;
  chartInstance->chartInfo.mdlStart = mdlStart_c28_ACX_Simulator;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c28_ACX_Simulator;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c28_ACX_Simulator_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c28_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c28_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c28_ACX_Simulator(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c28_ACX_Simulator_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
