/* Include files */

#include "blascompat32.h"
#include "ACX_Simulator_sfun.h"
#include "c88_ACX_Simulator.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ACX_Simulator_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c88_debug_family_names[5] = { "nargin", "nargout", "error",
  "deadband", "error_p" };

/* Function Declarations */
static void initialize_c88_ACX_Simulator(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initialize_params_c88_ACX_Simulator
  (SFc88_ACX_SimulatorInstanceStruct *chartInstance);
static void enable_c88_ACX_Simulator(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance);
static void disable_c88_ACX_Simulator(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance);
static void c88_update_debugger_state_c88_ACX_Simulator
  (SFc88_ACX_SimulatorInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c88_ACX_Simulator
  (SFc88_ACX_SimulatorInstanceStruct *chartInstance);
static void set_sim_state_c88_ACX_Simulator(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c88_st);
static void finalize_c88_ACX_Simulator(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance);
static void sf_c88_ACX_Simulator(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initSimStructsc88_ACX_Simulator(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c88_machineNumber, uint32_T
  c88_chartNumber);
static const mxArray *c88_sf_marshallOut(void *chartInstanceVoid, void
  *c88_inData);
static real_T c88_emlrt_marshallIn(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c88_error_p, const char_T *c88_identifier);
static real_T c88_b_emlrt_marshallIn(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c88_u, const emlrtMsgIdentifier *c88_parentId);
static void c88_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c88_mxArrayInData, const char_T *c88_varName, void *c88_outData);
static const mxArray *c88_b_sf_marshallOut(void *chartInstanceVoid, void
  *c88_inData);
static int32_T c88_c_emlrt_marshallIn(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c88_u, const emlrtMsgIdentifier *c88_parentId);
static void c88_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c88_mxArrayInData, const char_T *c88_varName, void *c88_outData);
static uint8_T c88_d_emlrt_marshallIn(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c88_b_is_active_c88_ACX_Simulator, const char_T
  *c88_identifier);
static uint8_T c88_e_emlrt_marshallIn(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c88_u, const emlrtMsgIdentifier *c88_parentId);
static void init_dsm_address_info(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c88_ACX_Simulator(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  chartInstance->c88_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c88_is_active_c88_ACX_Simulator = 0U;
}

static void initialize_params_c88_ACX_Simulator
  (SFc88_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static void enable_c88_ACX_Simulator(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c88_ACX_Simulator(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c88_update_debugger_state_c88_ACX_Simulator
  (SFc88_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c88_ACX_Simulator
  (SFc88_ACX_SimulatorInstanceStruct *chartInstance)
{
  const mxArray *c88_st;
  const mxArray *c88_y = NULL;
  real_T c88_hoistedGlobal;
  real_T c88_u;
  const mxArray *c88_b_y = NULL;
  uint8_T c88_b_hoistedGlobal;
  uint8_T c88_b_u;
  const mxArray *c88_c_y = NULL;
  real_T *c88_error_p;
  c88_error_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c88_st = NULL;
  c88_st = NULL;
  c88_y = NULL;
  sf_mex_assign(&c88_y, sf_mex_createcellarray(2));
  c88_hoistedGlobal = *c88_error_p;
  c88_u = c88_hoistedGlobal;
  c88_b_y = NULL;
  sf_mex_assign(&c88_b_y, sf_mex_create("y", &c88_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c88_y, 0, c88_b_y);
  c88_b_hoistedGlobal = chartInstance->c88_is_active_c88_ACX_Simulator;
  c88_b_u = c88_b_hoistedGlobal;
  c88_c_y = NULL;
  sf_mex_assign(&c88_c_y, sf_mex_create("y", &c88_b_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c88_y, 1, c88_c_y);
  sf_mex_assign(&c88_st, c88_y);
  return c88_st;
}

static void set_sim_state_c88_ACX_Simulator(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c88_st)
{
  const mxArray *c88_u;
  real_T *c88_error_p;
  c88_error_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c88_doneDoubleBufferReInit = TRUE;
  c88_u = sf_mex_dup(c88_st);
  *c88_error_p = c88_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c88_u, 0)), "error_p");
  chartInstance->c88_is_active_c88_ACX_Simulator = c88_d_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c88_u, 1)),
     "is_active_c88_ACX_Simulator");
  sf_mex_destroy(&c88_u);
  c88_update_debugger_state_c88_ACX_Simulator(chartInstance);
  sf_mex_destroy(&c88_st);
}

static void finalize_c88_ACX_Simulator(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void sf_c88_ACX_Simulator(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  real_T c88_hoistedGlobal;
  real_T c88_b_hoistedGlobal;
  real_T c88_error;
  real_T c88_deadband;
  uint32_T c88_debug_family_var_map[5];
  real_T c88_nargin = 2.0;
  real_T c88_nargout = 1.0;
  real_T c88_error_p;
  real_T c88_x;
  real_T c88_b_x;
  real_T c88_y;
  real_T *c88_b_error;
  real_T *c88_b_error_p;
  real_T *c88_b_deadband;
  c88_b_deadband = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c88_b_error_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c88_b_error = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 60U, chartInstance->c88_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c88_b_error, 0U);
  _SFD_DATA_RANGE_CHECK(*c88_b_error_p, 1U);
  _SFD_DATA_RANGE_CHECK(*c88_b_deadband, 2U);
  chartInstance->c88_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 60U, chartInstance->c88_sfEvent);
  c88_hoistedGlobal = *c88_b_error;
  c88_b_hoistedGlobal = *c88_b_deadband;
  c88_error = c88_hoistedGlobal;
  c88_deadband = c88_b_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 5U, 5U, c88_debug_family_names,
    c88_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c88_nargin, 0U, c88_sf_marshallOut,
    c88_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c88_nargout, 1U, c88_sf_marshallOut,
    c88_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c88_error, 2U, c88_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c88_deadband, 3U, c88_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c88_error_p, 4U, c88_sf_marshallOut,
    c88_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c88_sfEvent, 4);
  c88_error_p = c88_error;
  _SFD_EML_CALL(0U, chartInstance->c88_sfEvent, 6);
  c88_x = c88_error_p;
  c88_b_x = c88_x;
  c88_y = muDoubleScalarAbs(c88_b_x);
  if (CV_EML_IF(0, 0, c88_y <= c88_deadband)) {
    _SFD_EML_CALL(0U, chartInstance->c88_sfEvent, 7);
    c88_error_p = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c88_sfEvent, -7);
  sf_debug_symbol_scope_pop();
  *c88_b_error_p = c88_error_p;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 60U, chartInstance->c88_sfEvent);
  sf_debug_check_for_state_inconsistency(_ACX_SimulatorMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc88_ACX_Simulator(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c88_machineNumber, uint32_T
  c88_chartNumber)
{
}

static const mxArray *c88_sf_marshallOut(void *chartInstanceVoid, void
  *c88_inData)
{
  const mxArray *c88_mxArrayOutData = NULL;
  real_T c88_u;
  const mxArray *c88_y = NULL;
  SFc88_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc88_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c88_mxArrayOutData = NULL;
  c88_u = *(real_T *)c88_inData;
  c88_y = NULL;
  sf_mex_assign(&c88_y, sf_mex_create("y", &c88_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c88_mxArrayOutData, c88_y);
  return c88_mxArrayOutData;
}

static real_T c88_emlrt_marshallIn(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c88_error_p, const char_T *c88_identifier)
{
  real_T c88_y;
  emlrtMsgIdentifier c88_thisId;
  c88_thisId.fIdentifier = c88_identifier;
  c88_thisId.fParent = NULL;
  c88_y = c88_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c88_error_p),
    &c88_thisId);
  sf_mex_destroy(&c88_error_p);
  return c88_y;
}

static real_T c88_b_emlrt_marshallIn(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c88_u, const emlrtMsgIdentifier *c88_parentId)
{
  real_T c88_y;
  real_T c88_d0;
  sf_mex_import(c88_parentId, sf_mex_dup(c88_u), &c88_d0, 1, 0, 0U, 0, 0U, 0);
  c88_y = c88_d0;
  sf_mex_destroy(&c88_u);
  return c88_y;
}

static void c88_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c88_mxArrayInData, const char_T *c88_varName, void *c88_outData)
{
  const mxArray *c88_error_p;
  const char_T *c88_identifier;
  emlrtMsgIdentifier c88_thisId;
  real_T c88_y;
  SFc88_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc88_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c88_error_p = sf_mex_dup(c88_mxArrayInData);
  c88_identifier = c88_varName;
  c88_thisId.fIdentifier = c88_identifier;
  c88_thisId.fParent = NULL;
  c88_y = c88_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c88_error_p),
    &c88_thisId);
  sf_mex_destroy(&c88_error_p);
  *(real_T *)c88_outData = c88_y;
  sf_mex_destroy(&c88_mxArrayInData);
}

const mxArray *sf_c88_ACX_Simulator_get_eml_resolved_functions_info(void)
{
  const mxArray *c88_nameCaptureInfo;
  c88_ResolvedFunctionInfo c88_info[2];
  c88_ResolvedFunctionInfo (*c88_b_info)[2];
  const mxArray *c88_m0 = NULL;
  int32_T c88_i0;
  c88_ResolvedFunctionInfo *c88_r0;
  c88_nameCaptureInfo = NULL;
  c88_nameCaptureInfo = NULL;
  c88_b_info = (c88_ResolvedFunctionInfo (*)[2])c88_info;
  (*c88_b_info)[0].context = "";
  (*c88_b_info)[0].name = "abs";
  (*c88_b_info)[0].dominantType = "double";
  (*c88_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c88_b_info)[0].fileTimeLo = 1286818694U;
  (*c88_b_info)[0].fileTimeHi = 0U;
  (*c88_b_info)[0].mFileTimeLo = 0U;
  (*c88_b_info)[0].mFileTimeHi = 0U;
  (*c88_b_info)[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c88_b_info)[1].name = "eml_scalar_abs";
  (*c88_b_info)[1].dominantType = "double";
  (*c88_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  (*c88_b_info)[1].fileTimeLo = 1286818712U;
  (*c88_b_info)[1].fileTimeHi = 0U;
  (*c88_b_info)[1].mFileTimeLo = 0U;
  (*c88_b_info)[1].mFileTimeHi = 0U;
  sf_mex_assign(&c88_m0, sf_mex_createstruct("nameCaptureInfo", 1, 2));
  for (c88_i0 = 0; c88_i0 < 2; c88_i0++) {
    c88_r0 = &c88_info[c88_i0];
    sf_mex_addfield(c88_m0, sf_mex_create("nameCaptureInfo", c88_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c88_r0->context)), "context", "nameCaptureInfo",
                    c88_i0);
    sf_mex_addfield(c88_m0, sf_mex_create("nameCaptureInfo", c88_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c88_r0->name)), "name", "nameCaptureInfo", c88_i0);
    sf_mex_addfield(c88_m0, sf_mex_create("nameCaptureInfo",
      c88_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c88_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c88_i0);
    sf_mex_addfield(c88_m0, sf_mex_create("nameCaptureInfo", c88_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c88_r0->resolved)), "resolved",
                    "nameCaptureInfo", c88_i0);
    sf_mex_addfield(c88_m0, sf_mex_create("nameCaptureInfo", &c88_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c88_i0);
    sf_mex_addfield(c88_m0, sf_mex_create("nameCaptureInfo", &c88_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c88_i0);
    sf_mex_addfield(c88_m0, sf_mex_create("nameCaptureInfo",
      &c88_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c88_i0);
    sf_mex_addfield(c88_m0, sf_mex_create("nameCaptureInfo",
      &c88_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c88_i0);
  }

  sf_mex_assign(&c88_nameCaptureInfo, c88_m0);
  return c88_nameCaptureInfo;
}

static const mxArray *c88_b_sf_marshallOut(void *chartInstanceVoid, void
  *c88_inData)
{
  const mxArray *c88_mxArrayOutData = NULL;
  int32_T c88_u;
  const mxArray *c88_y = NULL;
  SFc88_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc88_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c88_mxArrayOutData = NULL;
  c88_u = *(int32_T *)c88_inData;
  c88_y = NULL;
  sf_mex_assign(&c88_y, sf_mex_create("y", &c88_u, 6, 0U, 0U, 0U, 0));
  sf_mex_assign(&c88_mxArrayOutData, c88_y);
  return c88_mxArrayOutData;
}

static int32_T c88_c_emlrt_marshallIn(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c88_u, const emlrtMsgIdentifier *c88_parentId)
{
  int32_T c88_y;
  int32_T c88_i1;
  sf_mex_import(c88_parentId, sf_mex_dup(c88_u), &c88_i1, 1, 6, 0U, 0, 0U, 0);
  c88_y = c88_i1;
  sf_mex_destroy(&c88_u);
  return c88_y;
}

static void c88_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c88_mxArrayInData, const char_T *c88_varName, void *c88_outData)
{
  const mxArray *c88_b_sfEvent;
  const char_T *c88_identifier;
  emlrtMsgIdentifier c88_thisId;
  int32_T c88_y;
  SFc88_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc88_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c88_b_sfEvent = sf_mex_dup(c88_mxArrayInData);
  c88_identifier = c88_varName;
  c88_thisId.fIdentifier = c88_identifier;
  c88_thisId.fParent = NULL;
  c88_y = c88_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c88_b_sfEvent),
    &c88_thisId);
  sf_mex_destroy(&c88_b_sfEvent);
  *(int32_T *)c88_outData = c88_y;
  sf_mex_destroy(&c88_mxArrayInData);
}

static uint8_T c88_d_emlrt_marshallIn(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c88_b_is_active_c88_ACX_Simulator, const char_T
  *c88_identifier)
{
  uint8_T c88_y;
  emlrtMsgIdentifier c88_thisId;
  c88_thisId.fIdentifier = c88_identifier;
  c88_thisId.fParent = NULL;
  c88_y = c88_e_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c88_b_is_active_c88_ACX_Simulator), &c88_thisId);
  sf_mex_destroy(&c88_b_is_active_c88_ACX_Simulator);
  return c88_y;
}

static uint8_T c88_e_emlrt_marshallIn(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c88_u, const emlrtMsgIdentifier *c88_parentId)
{
  uint8_T c88_y;
  uint8_T c88_u0;
  sf_mex_import(c88_parentId, sf_mex_dup(c88_u), &c88_u0, 1, 3, 0U, 0, 0U, 0);
  c88_y = c88_u0;
  sf_mex_destroy(&c88_u);
  return c88_y;
}

static void init_dsm_address_info(SFc88_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c88_ACX_Simulator_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2992538142U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(4024131966U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1721157547U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(72891633U);
}

mxArray *sf_c88_ACX_Simulator_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(723429194U);
    pr[1] = (double)(1606257593U);
    pr[2] = (double)(872721504U);
    pr[3] = (double)(1663426185U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c88_ACX_Simulator(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"error_p\",},{M[8],M[0],T\"is_active_c88_ACX_Simulator\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c88_ACX_Simulator_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc88_ACX_SimulatorInstanceStruct *chartInstance;
    chartInstance = (SFc88_ACX_SimulatorInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ACX_SimulatorMachineNumber_,
           88,
           1,
           1,
           3,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_ACX_SimulatorMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"error");
          _SFD_SET_DATA_PROPS(1,2,0,1,"error_p");
          _SFD_SET_DATA_PROPS(2,1,1,0,"deadband");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,131);
        _SFD_CV_INIT_EML_IF(0,0,79,105,-1,126);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c88_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c88_sf_marshallOut,(MexInFcnForType)c88_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c88_sf_marshallOut,(MexInFcnForType)NULL);

        {
          real_T *c88_error;
          real_T *c88_error_p;
          real_T *c88_deadband;
          c88_deadband = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c88_error_p = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c88_error = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c88_error);
          _SFD_SET_DATA_VALUE_PTR(1U, c88_error_p);
          _SFD_SET_DATA_VALUE_PTR(2U, c88_deadband);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ACX_SimulatorMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c88_ACX_Simulator(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc88_ACX_SimulatorInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c88_ACX_Simulator((SFc88_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
  initialize_c88_ACX_Simulator((SFc88_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c88_ACX_Simulator(void *chartInstanceVar)
{
  enable_c88_ACX_Simulator((SFc88_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c88_ACX_Simulator(void *chartInstanceVar)
{
  disable_c88_ACX_Simulator((SFc88_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c88_ACX_Simulator(void *chartInstanceVar)
{
  sf_c88_ACX_Simulator((SFc88_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c88_ACX_Simulator(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c88_ACX_Simulator
    ((SFc88_ACX_SimulatorInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c88_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c88_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c88_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c88_ACX_Simulator((SFc88_ACX_SimulatorInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c88_ACX_Simulator(SimStruct* S)
{
  return sf_internal_get_sim_state_c88_ACX_Simulator(S);
}

static void sf_opaque_set_sim_state_c88_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  sf_internal_set_sim_state_c88_ACX_Simulator(S, st);
}

static void sf_opaque_terminate_c88_ACX_Simulator(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc88_ACX_SimulatorInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c88_ACX_Simulator((SFc88_ACX_SimulatorInstanceStruct*)
      chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc88_ACX_Simulator((SFc88_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c88_ACX_Simulator(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c88_ACX_Simulator((SFc88_ACX_SimulatorInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c88_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,"ACX_Simulator","ACX_Simulator",88);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,"ACX_Simulator","ACX_Simulator",88,
                "RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,"ACX_Simulator",
      "ACX_Simulator",88,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"ACX_Simulator","ACX_Simulator",88,2);
      sf_mark_chart_reusable_outputs(S,"ACX_Simulator","ACX_Simulator",88,1);
    }

    sf_set_rtw_dwork_info(S,"ACX_Simulator","ACX_Simulator",88);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(4081331470U));
  ssSetChecksum1(S,(1262144024U));
  ssSetChecksum2(S,(2177743531U));
  ssSetChecksum3(S,(2365723256U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c88_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "ACX_Simulator", "ACX_Simulator",88);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c88_ACX_Simulator(SimStruct *S)
{
  SFc88_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc88_ACX_SimulatorInstanceStruct *)malloc(sizeof
    (SFc88_ACX_SimulatorInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc88_ACX_SimulatorInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c88_ACX_Simulator;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c88_ACX_Simulator;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c88_ACX_Simulator;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c88_ACX_Simulator;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c88_ACX_Simulator;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c88_ACX_Simulator;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c88_ACX_Simulator;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c88_ACX_Simulator;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c88_ACX_Simulator;
  chartInstance->chartInfo.mdlStart = mdlStart_c88_ACX_Simulator;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c88_ACX_Simulator;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c88_ACX_Simulator_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c88_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c88_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c88_ACX_Simulator(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c88_ACX_Simulator_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
