%%  ACX HEAVE SISO PD CONTROL
%
%   Authors: Konstantinos Alexis (konstantinos.alexis@mavt.ethz.ch)

%%  

Az = zeros(2,2);
Az(2,2) = w_miso_ss.A(1);
Az(1,2) = 1;
Bz = zeros(2,1);
Bz(2,1) = w_miso_ss.B(1,2);

z_siso_ss = ss(Az,Bz,eye(1,2),zeros(1,1));
z_siso_tf = tf(z_siso_ss);
z_siso_tf_u_thrust = z_siso_ss*Ut_rpm; 

PD_HEAVE.Kp = 0.01588;
PD_HEAVE.Kd = 0.01588*0.62;
PD_HEAVE.Ki = 0;

%%