/* Include files */

#include "blascompat32.h"
#include "ACX_Simulator_sfun.h"
#include "c49_ACX_Simulator.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ACX_Simulator_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c49_debug_family_names[28] = { "lenX", "x_meas", "y_meas",
  "x_meas_r", "y_meas_r", "X_WPT_CUR_r", "Y_WPT_CUR_r", "delta_X_r", "nargin",
  "nargout", "X_WPTs", "Y_WPTs", "XY_MEAS", "counter", "dist_thres", "X_WPT_CUR",
  "Y_WPT_CUR", "heading_prev", "SM_FLAG", "initFLAG", "X_WPT_OUT", "Y_WPT_OUT",
  "heading", "counter_out", "stopFlag", "initFLAG_out", "dista", "flag_lastWPT"
};

/* Function Declarations */
static void initialize_c49_ACX_Simulator(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initialize_params_c49_ACX_Simulator
  (SFc49_ACX_SimulatorInstanceStruct *chartInstance);
static void enable_c49_ACX_Simulator(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance);
static void disable_c49_ACX_Simulator(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance);
static void c49_update_debugger_state_c49_ACX_Simulator
  (SFc49_ACX_SimulatorInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c49_ACX_Simulator
  (SFc49_ACX_SimulatorInstanceStruct *chartInstance);
static void set_sim_state_c49_ACX_Simulator(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c49_st);
static void finalize_c49_ACX_Simulator(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance);
static void sf_c49_ACX_Simulator(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance);
static void c49_chartstep_c49_ACX_Simulator(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initSimStructsc49_ACX_Simulator(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c49_machineNumber, uint32_T
  c49_chartNumber);
static const mxArray *c49_sf_marshallOut(void *chartInstanceVoid, void
  *c49_inData);
static real_T c49_emlrt_marshallIn(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c49_flag_lastWPT, const char_T *c49_identifier);
static real_T c49_b_emlrt_marshallIn(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c49_u, const emlrtMsgIdentifier *c49_parentId);
static void c49_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c49_mxArrayInData, const char_T *c49_varName, void *c49_outData);
static const mxArray *c49_b_sf_marshallOut(void *chartInstanceVoid, void
  *c49_inData);
static const mxArray *c49_c_sf_marshallOut(void *chartInstanceVoid, void
  *c49_inData);
static void c49_info_helper(c49_ResolvedFunctionInfo c49_info[16]);
static real_T c49_mpower(SFc49_ACX_SimulatorInstanceStruct *chartInstance,
  real_T c49_a);
static void c49_eml_scalar_eg(SFc49_ACX_SimulatorInstanceStruct *chartInstance);
static void c49_eml_error(SFc49_ACX_SimulatorInstanceStruct *chartInstance);
static const mxArray *c49_d_sf_marshallOut(void *chartInstanceVoid, void
  *c49_inData);
static int32_T c49_c_emlrt_marshallIn(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c49_u, const emlrtMsgIdentifier *c49_parentId);
static void c49_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c49_mxArrayInData, const char_T *c49_varName, void *c49_outData);
static uint8_T c49_d_emlrt_marshallIn(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c49_b_is_active_c49_ACX_Simulator, const char_T
  *c49_identifier);
static uint8_T c49_e_emlrt_marshallIn(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c49_u, const emlrtMsgIdentifier *c49_parentId);
static void init_dsm_address_info(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c49_ACX_Simulator(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  chartInstance->c49_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c49_is_active_c49_ACX_Simulator = 0U;
}

static void initialize_params_c49_ACX_Simulator
  (SFc49_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static void enable_c49_ACX_Simulator(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c49_ACX_Simulator(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c49_update_debugger_state_c49_ACX_Simulator
  (SFc49_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c49_ACX_Simulator
  (SFc49_ACX_SimulatorInstanceStruct *chartInstance)
{
  const mxArray *c49_st;
  const mxArray *c49_y = NULL;
  real_T c49_hoistedGlobal;
  real_T c49_u;
  const mxArray *c49_b_y = NULL;
  real_T c49_b_hoistedGlobal;
  real_T c49_b_u;
  const mxArray *c49_c_y = NULL;
  real_T c49_c_hoistedGlobal;
  real_T c49_c_u;
  const mxArray *c49_d_y = NULL;
  real_T c49_d_hoistedGlobal;
  real_T c49_d_u;
  const mxArray *c49_e_y = NULL;
  real_T c49_e_hoistedGlobal;
  real_T c49_e_u;
  const mxArray *c49_f_y = NULL;
  real_T c49_f_hoistedGlobal;
  real_T c49_f_u;
  const mxArray *c49_g_y = NULL;
  real_T c49_g_hoistedGlobal;
  real_T c49_g_u;
  const mxArray *c49_h_y = NULL;
  real_T c49_h_hoistedGlobal;
  real_T c49_h_u;
  const mxArray *c49_i_y = NULL;
  uint8_T c49_i_hoistedGlobal;
  uint8_T c49_i_u;
  const mxArray *c49_j_y = NULL;
  real_T *c49_X_WPT_OUT;
  real_T *c49_Y_WPT_OUT;
  real_T *c49_counter_out;
  real_T *c49_dista;
  real_T *c49_flag_lastWPT;
  real_T *c49_heading;
  real_T *c49_initFLAG_out;
  real_T *c49_stopFlag;
  c49_flag_lastWPT = (real_T *)ssGetOutputPortSignal(chartInstance->S, 8);
  c49_dista = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
  c49_initFLAG_out = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c49_stopFlag = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c49_counter_out = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c49_heading = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c49_Y_WPT_OUT = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c49_X_WPT_OUT = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c49_st = NULL;
  c49_st = NULL;
  c49_y = NULL;
  sf_mex_assign(&c49_y, sf_mex_createcellarray(9));
  c49_hoistedGlobal = *c49_X_WPT_OUT;
  c49_u = c49_hoistedGlobal;
  c49_b_y = NULL;
  sf_mex_assign(&c49_b_y, sf_mex_create("y", &c49_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c49_y, 0, c49_b_y);
  c49_b_hoistedGlobal = *c49_Y_WPT_OUT;
  c49_b_u = c49_b_hoistedGlobal;
  c49_c_y = NULL;
  sf_mex_assign(&c49_c_y, sf_mex_create("y", &c49_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c49_y, 1, c49_c_y);
  c49_c_hoistedGlobal = *c49_counter_out;
  c49_c_u = c49_c_hoistedGlobal;
  c49_d_y = NULL;
  sf_mex_assign(&c49_d_y, sf_mex_create("y", &c49_c_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c49_y, 2, c49_d_y);
  c49_d_hoistedGlobal = *c49_dista;
  c49_d_u = c49_d_hoistedGlobal;
  c49_e_y = NULL;
  sf_mex_assign(&c49_e_y, sf_mex_create("y", &c49_d_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c49_y, 3, c49_e_y);
  c49_e_hoistedGlobal = *c49_flag_lastWPT;
  c49_e_u = c49_e_hoistedGlobal;
  c49_f_y = NULL;
  sf_mex_assign(&c49_f_y, sf_mex_create("y", &c49_e_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c49_y, 4, c49_f_y);
  c49_f_hoistedGlobal = *c49_heading;
  c49_f_u = c49_f_hoistedGlobal;
  c49_g_y = NULL;
  sf_mex_assign(&c49_g_y, sf_mex_create("y", &c49_f_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c49_y, 5, c49_g_y);
  c49_g_hoistedGlobal = *c49_initFLAG_out;
  c49_g_u = c49_g_hoistedGlobal;
  c49_h_y = NULL;
  sf_mex_assign(&c49_h_y, sf_mex_create("y", &c49_g_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c49_y, 6, c49_h_y);
  c49_h_hoistedGlobal = *c49_stopFlag;
  c49_h_u = c49_h_hoistedGlobal;
  c49_i_y = NULL;
  sf_mex_assign(&c49_i_y, sf_mex_create("y", &c49_h_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c49_y, 7, c49_i_y);
  c49_i_hoistedGlobal = chartInstance->c49_is_active_c49_ACX_Simulator;
  c49_i_u = c49_i_hoistedGlobal;
  c49_j_y = NULL;
  sf_mex_assign(&c49_j_y, sf_mex_create("y", &c49_i_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c49_y, 8, c49_j_y);
  sf_mex_assign(&c49_st, c49_y);
  return c49_st;
}

static void set_sim_state_c49_ACX_Simulator(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c49_st)
{
  const mxArray *c49_u;
  real_T *c49_X_WPT_OUT;
  real_T *c49_Y_WPT_OUT;
  real_T *c49_counter_out;
  real_T *c49_dista;
  real_T *c49_flag_lastWPT;
  real_T *c49_heading;
  real_T *c49_initFLAG_out;
  real_T *c49_stopFlag;
  c49_flag_lastWPT = (real_T *)ssGetOutputPortSignal(chartInstance->S, 8);
  c49_dista = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
  c49_initFLAG_out = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c49_stopFlag = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c49_counter_out = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c49_heading = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c49_Y_WPT_OUT = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c49_X_WPT_OUT = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c49_doneDoubleBufferReInit = TRUE;
  c49_u = sf_mex_dup(c49_st);
  *c49_X_WPT_OUT = c49_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c49_u, 0)), "X_WPT_OUT");
  *c49_Y_WPT_OUT = c49_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c49_u, 1)), "Y_WPT_OUT");
  *c49_counter_out = c49_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c49_u, 2)), "counter_out");
  *c49_dista = c49_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c49_u, 3)), "dista");
  *c49_flag_lastWPT = c49_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c49_u, 4)), "flag_lastWPT");
  *c49_heading = c49_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c49_u, 5)), "heading");
  *c49_initFLAG_out = c49_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c49_u, 6)), "initFLAG_out");
  *c49_stopFlag = c49_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c49_u, 7)), "stopFlag");
  chartInstance->c49_is_active_c49_ACX_Simulator = c49_d_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c49_u, 8)),
     "is_active_c49_ACX_Simulator");
  sf_mex_destroy(&c49_u);
  c49_update_debugger_state_c49_ACX_Simulator(chartInstance);
  sf_mex_destroy(&c49_st);
}

static void finalize_c49_ACX_Simulator(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void sf_c49_ACX_Simulator(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  int32_T c49_i0;
  int32_T c49_i1;
  int32_T c49_i2;
  real_T *c49_X_WPT_OUT;
  real_T *c49_counter;
  real_T *c49_dist_thres;
  real_T *c49_Y_WPT_OUT;
  real_T *c49_heading;
  real_T *c49_counter_out;
  real_T *c49_X_WPT_CUR;
  real_T *c49_Y_WPT_CUR;
  real_T *c49_heading_prev;
  real_T *c49_stopFlag;
  real_T *c49_SM_FLAG;
  real_T *c49_initFLAG;
  real_T *c49_initFLAG_out;
  real_T *c49_dista;
  real_T *c49_flag_lastWPT;
  real_T (*c49_XY_MEAS)[2];
  real_T (*c49_Y_WPTs)[31];
  real_T (*c49_X_WPTs)[31];
  c49_flag_lastWPT = (real_T *)ssGetOutputPortSignal(chartInstance->S, 8);
  c49_dista = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
  c49_initFLAG_out = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c49_initFLAG = (real_T *)ssGetInputPortSignal(chartInstance->S, 9);
  c49_SM_FLAG = (real_T *)ssGetInputPortSignal(chartInstance->S, 8);
  c49_stopFlag = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c49_heading_prev = (real_T *)ssGetInputPortSignal(chartInstance->S, 7);
  c49_Y_WPT_CUR = (real_T *)ssGetInputPortSignal(chartInstance->S, 6);
  c49_X_WPT_CUR = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
  c49_counter_out = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c49_heading = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c49_Y_WPT_OUT = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c49_dist_thres = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c49_counter = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c49_XY_MEAS = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 2);
  c49_Y_WPTs = (real_T (*)[31])ssGetInputPortSignal(chartInstance->S, 1);
  c49_X_WPT_OUT = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c49_X_WPTs = (real_T (*)[31])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 48U, chartInstance->c49_sfEvent);
  for (c49_i0 = 0; c49_i0 < 31; c49_i0++) {
    _SFD_DATA_RANGE_CHECK((*c49_X_WPTs)[c49_i0], 0U);
  }

  _SFD_DATA_RANGE_CHECK(*c49_X_WPT_OUT, 1U);
  for (c49_i1 = 0; c49_i1 < 31; c49_i1++) {
    _SFD_DATA_RANGE_CHECK((*c49_Y_WPTs)[c49_i1], 2U);
  }

  for (c49_i2 = 0; c49_i2 < 2; c49_i2++) {
    _SFD_DATA_RANGE_CHECK((*c49_XY_MEAS)[c49_i2], 3U);
  }

  _SFD_DATA_RANGE_CHECK(*c49_counter, 4U);
  _SFD_DATA_RANGE_CHECK(*c49_dist_thres, 5U);
  _SFD_DATA_RANGE_CHECK(*c49_Y_WPT_OUT, 6U);
  _SFD_DATA_RANGE_CHECK(*c49_heading, 7U);
  _SFD_DATA_RANGE_CHECK(*c49_counter_out, 8U);
  _SFD_DATA_RANGE_CHECK(*c49_X_WPT_CUR, 9U);
  _SFD_DATA_RANGE_CHECK(*c49_Y_WPT_CUR, 10U);
  _SFD_DATA_RANGE_CHECK(*c49_heading_prev, 11U);
  _SFD_DATA_RANGE_CHECK(*c49_stopFlag, 12U);
  _SFD_DATA_RANGE_CHECK(*c49_SM_FLAG, 13U);
  _SFD_DATA_RANGE_CHECK(*c49_initFLAG, 14U);
  _SFD_DATA_RANGE_CHECK(*c49_initFLAG_out, 15U);
  _SFD_DATA_RANGE_CHECK(*c49_dista, 16U);
  _SFD_DATA_RANGE_CHECK(*c49_flag_lastWPT, 17U);
  chartInstance->c49_sfEvent = CALL_EVENT;
  c49_chartstep_c49_ACX_Simulator(chartInstance);
  sf_debug_check_for_state_inconsistency(_ACX_SimulatorMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c49_chartstep_c49_ACX_Simulator(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  real_T c49_hoistedGlobal;
  real_T c49_b_hoistedGlobal;
  real_T c49_c_hoistedGlobal;
  real_T c49_d_hoistedGlobal;
  real_T c49_e_hoistedGlobal;
  real_T c49_f_hoistedGlobal;
  real_T c49_g_hoistedGlobal;
  int32_T c49_i3;
  real_T c49_X_WPTs[31];
  int32_T c49_i4;
  real_T c49_Y_WPTs[31];
  int32_T c49_i5;
  real_T c49_XY_MEAS[2];
  real_T c49_counter;
  real_T c49_dist_thres;
  real_T c49_X_WPT_CUR;
  real_T c49_Y_WPT_CUR;
  real_T c49_heading_prev;
  real_T c49_SM_FLAG;
  real_T c49_initFLAG;
  uint32_T c49_debug_family_var_map[28];
  real_T c49_lenX;
  real_T c49_x_meas;
  real_T c49_y_meas;
  real_T c49_x_meas_r;
  real_T c49_y_meas_r;
  real_T c49_X_WPT_CUR_r;
  real_T c49_Y_WPT_CUR_r;
  real_T c49_delta_X_r;
  real_T c49_nargin = 10.0;
  real_T c49_nargout = 8.0;
  real_T c49_X_WPT_OUT;
  real_T c49_Y_WPT_OUT;
  real_T c49_heading;
  real_T c49_counter_out;
  real_T c49_stopFlag;
  real_T c49_initFLAG_out;
  real_T c49_dista;
  real_T c49_flag_lastWPT;
  real_T c49_x;
  real_T c49_b_x;
  real_T c49_a;
  real_T c49_b;
  real_T c49_y;
  real_T c49_c_x;
  real_T c49_d_x;
  real_T c49_b_a;
  real_T c49_b_b;
  real_T c49_b_y;
  real_T c49_e_x;
  real_T c49_f_x;
  real_T c49_c_a;
  real_T c49_c_b;
  real_T c49_c_y;
  real_T c49_g_x;
  real_T c49_h_x;
  real_T c49_d_a;
  real_T c49_d_b;
  real_T c49_d_y;
  real_T c49_i_x;
  real_T c49_j_x;
  real_T c49_e_a;
  real_T c49_e_b;
  real_T c49_e_y;
  real_T c49_k_x;
  real_T c49_l_x;
  real_T c49_f_a;
  real_T c49_f_b;
  real_T c49_f_y;
  real_T c49_m_x;
  real_T c49_n_x;
  real_T c49_g_a;
  real_T c49_g_b;
  real_T c49_g_y;
  real_T c49_o_x;
  real_T c49_p_x;
  real_T c49_h_a;
  real_T c49_h_b;
  real_T c49_h_y;
  real_T c49_q_x;
  real_T c49_r_x;
  real_T c49_i_b;
  real_T c49_i_y;
  real_T c49_s_x;
  real_T c49_j_y;
  real_T c49_t_x;
  real_T *c49_b_counter;
  real_T *c49_b_dist_thres;
  real_T *c49_b_X_WPT_CUR;
  real_T *c49_b_Y_WPT_CUR;
  real_T *c49_b_heading_prev;
  real_T *c49_b_SM_FLAG;
  real_T *c49_b_initFLAG;
  real_T *c49_b_X_WPT_OUT;
  real_T *c49_b_Y_WPT_OUT;
  real_T *c49_b_heading;
  real_T *c49_b_counter_out;
  real_T *c49_b_stopFlag;
  real_T *c49_b_initFLAG_out;
  real_T *c49_b_dista;
  real_T *c49_b_flag_lastWPT;
  real_T (*c49_b_XY_MEAS)[2];
  real_T (*c49_b_Y_WPTs)[31];
  real_T (*c49_b_X_WPTs)[31];
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  boolean_T guard4 = FALSE;
  c49_b_flag_lastWPT = (real_T *)ssGetOutputPortSignal(chartInstance->S, 8);
  c49_b_dista = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
  c49_b_initFLAG_out = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c49_b_initFLAG = (real_T *)ssGetInputPortSignal(chartInstance->S, 9);
  c49_b_SM_FLAG = (real_T *)ssGetInputPortSignal(chartInstance->S, 8);
  c49_b_stopFlag = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c49_b_heading_prev = (real_T *)ssGetInputPortSignal(chartInstance->S, 7);
  c49_b_Y_WPT_CUR = (real_T *)ssGetInputPortSignal(chartInstance->S, 6);
  c49_b_X_WPT_CUR = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
  c49_b_counter_out = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c49_b_heading = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c49_b_Y_WPT_OUT = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c49_b_dist_thres = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c49_b_counter = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c49_b_XY_MEAS = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 2);
  c49_b_Y_WPTs = (real_T (*)[31])ssGetInputPortSignal(chartInstance->S, 1);
  c49_b_X_WPT_OUT = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c49_b_X_WPTs = (real_T (*)[31])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 48U, chartInstance->c49_sfEvent);
  c49_hoistedGlobal = *c49_b_counter;
  c49_b_hoistedGlobal = *c49_b_dist_thres;
  c49_c_hoistedGlobal = *c49_b_X_WPT_CUR;
  c49_d_hoistedGlobal = *c49_b_Y_WPT_CUR;
  c49_e_hoistedGlobal = *c49_b_heading_prev;
  c49_f_hoistedGlobal = *c49_b_SM_FLAG;
  c49_g_hoistedGlobal = *c49_b_initFLAG;
  for (c49_i3 = 0; c49_i3 < 31; c49_i3++) {
    c49_X_WPTs[c49_i3] = (*c49_b_X_WPTs)[c49_i3];
  }

  for (c49_i4 = 0; c49_i4 < 31; c49_i4++) {
    c49_Y_WPTs[c49_i4] = (*c49_b_Y_WPTs)[c49_i4];
  }

  for (c49_i5 = 0; c49_i5 < 2; c49_i5++) {
    c49_XY_MEAS[c49_i5] = (*c49_b_XY_MEAS)[c49_i5];
  }

  c49_counter = c49_hoistedGlobal;
  c49_dist_thres = c49_b_hoistedGlobal;
  c49_X_WPT_CUR = c49_c_hoistedGlobal;
  c49_Y_WPT_CUR = c49_d_hoistedGlobal;
  c49_heading_prev = c49_e_hoistedGlobal;
  c49_SM_FLAG = c49_f_hoistedGlobal;
  c49_initFLAG = c49_g_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 28U, 28U, c49_debug_family_names,
    c49_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c49_lenX, 0U, c49_sf_marshallOut,
    c49_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c49_x_meas, 1U, c49_sf_marshallOut,
    c49_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c49_y_meas, 2U, c49_sf_marshallOut,
    c49_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c49_x_meas_r, 3U, c49_sf_marshallOut,
    c49_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c49_y_meas_r, 4U, c49_sf_marshallOut,
    c49_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c49_X_WPT_CUR_r, 5U,
    c49_sf_marshallOut, c49_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c49_Y_WPT_CUR_r, 6U,
    c49_sf_marshallOut, c49_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c49_delta_X_r, 7U,
    c49_sf_marshallOut, c49_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c49_nargin, 8U, c49_sf_marshallOut,
    c49_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c49_nargout, 9U, c49_sf_marshallOut,
    c49_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c49_X_WPTs, 10U, c49_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c49_Y_WPTs, 11U, c49_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c49_XY_MEAS, 12U, c49_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c49_counter, 13U, c49_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c49_dist_thres, 14U, c49_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c49_X_WPT_CUR, 15U, c49_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c49_Y_WPT_CUR, 16U, c49_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c49_heading_prev, 17U, c49_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c49_SM_FLAG, 18U, c49_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c49_initFLAG, 19U, c49_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c49_X_WPT_OUT, 20U,
    c49_sf_marshallOut, c49_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c49_Y_WPT_OUT, 21U,
    c49_sf_marshallOut, c49_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c49_heading, 22U, c49_sf_marshallOut,
    c49_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c49_counter_out, 23U,
    c49_sf_marshallOut, c49_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c49_stopFlag, 24U,
    c49_sf_marshallOut, c49_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c49_initFLAG_out, 25U,
    c49_sf_marshallOut, c49_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c49_dista, 26U, c49_sf_marshallOut,
    c49_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c49_flag_lastWPT, 27U,
    c49_sf_marshallOut, c49_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 4);
  c49_lenX = 31.0;
  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 7);
  c49_x_meas = c49_XY_MEAS[0];
  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 8);
  c49_y_meas = c49_XY_MEAS[1];
  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 10);
  c49_x = c49_heading_prev;
  c49_b_x = c49_x;
  c49_b_x = muDoubleScalarCos(c49_b_x);
  c49_a = c49_x_meas;
  c49_b = c49_b_x;
  c49_y = c49_a * c49_b;
  c49_c_x = c49_heading_prev;
  c49_d_x = c49_c_x;
  c49_d_x = muDoubleScalarSin(c49_d_x);
  c49_b_a = c49_y_meas;
  c49_b_b = c49_d_x;
  c49_b_y = c49_b_a * c49_b_b;
  c49_x_meas_r = c49_y + c49_b_y;
  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 11);
  c49_e_x = c49_heading_prev;
  c49_f_x = c49_e_x;
  c49_f_x = muDoubleScalarSin(c49_f_x);
  c49_c_a = -c49_x_meas;
  c49_c_b = c49_f_x;
  c49_c_y = c49_c_a * c49_c_b;
  c49_g_x = c49_heading_prev;
  c49_h_x = c49_g_x;
  c49_h_x = muDoubleScalarCos(c49_h_x);
  c49_d_a = c49_y_meas;
  c49_d_b = c49_h_x;
  c49_d_y = c49_d_a * c49_d_b;
  c49_y_meas_r = c49_c_y + c49_d_y;
  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 13);
  c49_i_x = c49_heading_prev;
  c49_j_x = c49_i_x;
  c49_j_x = muDoubleScalarCos(c49_j_x);
  c49_e_a = c49_X_WPT_CUR;
  c49_e_b = c49_j_x;
  c49_e_y = c49_e_a * c49_e_b;
  c49_k_x = c49_heading_prev;
  c49_l_x = c49_k_x;
  c49_l_x = muDoubleScalarSin(c49_l_x);
  c49_f_a = c49_Y_WPT_CUR;
  c49_f_b = c49_l_x;
  c49_f_y = c49_f_a * c49_f_b;
  c49_X_WPT_CUR_r = c49_e_y + c49_f_y;
  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 14);
  c49_m_x = c49_heading_prev;
  c49_n_x = c49_m_x;
  c49_n_x = muDoubleScalarSin(c49_n_x);
  c49_g_a = -c49_X_WPT_CUR;
  c49_g_b = c49_n_x;
  c49_g_y = c49_g_a * c49_g_b;
  c49_o_x = c49_heading_prev;
  c49_p_x = c49_o_x;
  c49_p_x = muDoubleScalarCos(c49_p_x);
  c49_h_a = c49_Y_WPT_CUR;
  c49_h_b = c49_p_x;
  c49_h_y = c49_h_a * c49_h_b;
  c49_Y_WPT_CUR_r = c49_g_y + c49_h_y;
  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 16);
  c49_delta_X_r = c49_x_meas_r - c49_X_WPT_CUR_r;
  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 18);
  c49_q_x = c49_mpower(chartInstance, c49_x_meas - c49_X_WPT_CUR) + c49_mpower
    (chartInstance, c49_y_meas - c49_Y_WPT_CUR);
  c49_dista = c49_q_x;
  if (c49_dista < 0.0) {
    c49_eml_error(chartInstance);
  }

  c49_r_x = c49_dista;
  c49_dista = c49_r_x;
  c49_dista = muDoubleScalarSqrt(c49_dista);
  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 20);
  c49_initFLAG_out = c49_initFLAG;
  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 21);
  guard4 = FALSE;
  if (CV_EML_COND(0, 0, c49_SM_FLAG == 1.0)) {
    if (CV_EML_COND(0, 1, c49_initFLAG_out == 0.0)) {
      CV_EML_MCDC(0, 0, TRUE);
      CV_EML_IF(0, 0, TRUE);
      _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 22);
      c49_initFLAG_out = 1.0;
    } else {
      guard4 = TRUE;
    }
  } else {
    guard4 = TRUE;
  }

  if (guard4 == TRUE) {
    CV_EML_MCDC(0, 0, FALSE);
    CV_EML_IF(0, 0, FALSE);
  }

  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 25);
  guard3 = FALSE;
  if (CV_EML_COND(0, 2, c49_SM_FLAG == 1.0)) {
    if (CV_EML_COND(0, 3, c49_initFLAG_out == 1.0)) {
      CV_EML_MCDC(0, 1, TRUE);
      CV_EML_IF(0, 1, TRUE);
      _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 26);
      c49_X_WPT_CUR = c49_x_meas;
      _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 27);
      c49_Y_WPT_CUR = c49_y_meas;
      _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 28);
      c49_initFLAG_out = 2.0;
    } else {
      guard3 = TRUE;
    }
  } else {
    guard3 = TRUE;
  }

  if (guard3 == TRUE) {
    CV_EML_MCDC(0, 1, FALSE);
    CV_EML_IF(0, 1, FALSE);
  }

  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 31);
  guard2 = FALSE;
  if (CV_EML_COND(0, 4, c49_SM_FLAG != 1.0)) {
    if (CV_EML_COND(0, 5, c49_initFLAG_out == 0.0)) {
      CV_EML_MCDC(0, 2, TRUE);
      CV_EML_IF(0, 2, TRUE);
      _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 32);
      c49_i_b = c49_dist_thres;
      c49_dista = 2.0 * c49_i_b;
      _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 33);
      c49_X_WPT_CUR = c49_x_meas;
      _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 34);
      c49_Y_WPT_CUR = c49_y_meas;
    } else {
      guard2 = TRUE;
    }
  } else {
    guard2 = TRUE;
  }

  if (guard2 == TRUE) {
    CV_EML_MCDC(0, 2, FALSE);
    CV_EML_IF(0, 2, FALSE);
  }

  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 37);
  c49_flag_lastWPT = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 38);
  if (CV_EML_IF(0, 3, c49_counter == c49_lenX)) {
    _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 39);
    c49_flag_lastWPT = 1.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 42);
  c49_stopFlag = -1.0;
  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 43);
  c49_heading = c49_heading_prev;
  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 44);
  guard1 = FALSE;
  if (CV_EML_COND(0, 6, c49_dista <= c49_dist_thres)) {
    guard1 = TRUE;
  } else if (CV_EML_COND(0, 7, c49_delta_X_r > 0.0)) {
    guard1 = TRUE;
  } else {
    CV_EML_MCDC(0, 3, FALSE);
    CV_EML_IF(0, 4, FALSE);
    _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 64);
    c49_X_WPT_OUT = c49_X_WPT_CUR;
    _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 65);
    c49_Y_WPT_OUT = c49_Y_WPT_CUR;
  }

  if (guard1 == TRUE) {
    CV_EML_MCDC(0, 3, TRUE);
    CV_EML_IF(0, 4, TRUE);
    _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 45);
    c49_counter++;
    _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 46);
    if (CV_EML_IF(0, 5, c49_counter > c49_lenX)) {
      _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 47);
      c49_stopFlag = 1.0;
    } else {
      _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 49);
      c49_stopFlag = -1.0;
    }

    _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 52);
    if (CV_EML_IF(0, 6, c49_counter <= 31.0)) {
      _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 54);
      c49_X_WPT_OUT = c49_X_WPTs[_SFD_EML_ARRAY_BOUNDS_CHECK("X_WPTs", (int32_T)
        _SFD_INTEGER_CHECK("counter", c49_counter), 1, 31, 1, 0) - 1];
      _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 55);
      c49_Y_WPT_OUT = c49_Y_WPTs[_SFD_EML_ARRAY_BOUNDS_CHECK("Y_WPTs", (int32_T)
        _SFD_INTEGER_CHECK("counter", c49_counter), 1, 31, 1, 0) - 1];
      _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 56);
      c49_i_y = c49_Y_WPT_OUT - c49_Y_WPT_CUR;
      c49_s_x = c49_X_WPT_OUT - c49_X_WPT_CUR;
      c49_eml_scalar_eg(chartInstance);
      c49_j_y = c49_i_y;
      c49_t_x = c49_s_x;
      c49_heading = muDoubleScalarAtan2(c49_j_y, c49_t_x);
    } else {
      _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 60);
      c49_X_WPT_OUT = c49_X_WPT_CUR;
      _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 61);
      c49_Y_WPT_OUT = c49_Y_WPT_CUR;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, 67);
  c49_counter_out = c49_counter;
  _SFD_EML_CALL(0U, chartInstance->c49_sfEvent, -67);
  sf_debug_symbol_scope_pop();
  *c49_b_X_WPT_OUT = c49_X_WPT_OUT;
  *c49_b_Y_WPT_OUT = c49_Y_WPT_OUT;
  *c49_b_heading = c49_heading;
  *c49_b_counter_out = c49_counter_out;
  *c49_b_stopFlag = c49_stopFlag;
  *c49_b_initFLAG_out = c49_initFLAG_out;
  *c49_b_dista = c49_dista;
  *c49_b_flag_lastWPT = c49_flag_lastWPT;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 48U, chartInstance->c49_sfEvent);
}

static void initSimStructsc49_ACX_Simulator(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c49_machineNumber, uint32_T
  c49_chartNumber)
{
}

static const mxArray *c49_sf_marshallOut(void *chartInstanceVoid, void
  *c49_inData)
{
  const mxArray *c49_mxArrayOutData = NULL;
  real_T c49_u;
  const mxArray *c49_y = NULL;
  SFc49_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc49_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c49_mxArrayOutData = NULL;
  c49_u = *(real_T *)c49_inData;
  c49_y = NULL;
  sf_mex_assign(&c49_y, sf_mex_create("y", &c49_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c49_mxArrayOutData, c49_y);
  return c49_mxArrayOutData;
}

static real_T c49_emlrt_marshallIn(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c49_flag_lastWPT, const char_T *c49_identifier)
{
  real_T c49_y;
  emlrtMsgIdentifier c49_thisId;
  c49_thisId.fIdentifier = c49_identifier;
  c49_thisId.fParent = NULL;
  c49_y = c49_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c49_flag_lastWPT),
    &c49_thisId);
  sf_mex_destroy(&c49_flag_lastWPT);
  return c49_y;
}

static real_T c49_b_emlrt_marshallIn(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c49_u, const emlrtMsgIdentifier *c49_parentId)
{
  real_T c49_y;
  real_T c49_d0;
  sf_mex_import(c49_parentId, sf_mex_dup(c49_u), &c49_d0, 1, 0, 0U, 0, 0U, 0);
  c49_y = c49_d0;
  sf_mex_destroy(&c49_u);
  return c49_y;
}

static void c49_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c49_mxArrayInData, const char_T *c49_varName, void *c49_outData)
{
  const mxArray *c49_flag_lastWPT;
  const char_T *c49_identifier;
  emlrtMsgIdentifier c49_thisId;
  real_T c49_y;
  SFc49_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc49_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c49_flag_lastWPT = sf_mex_dup(c49_mxArrayInData);
  c49_identifier = c49_varName;
  c49_thisId.fIdentifier = c49_identifier;
  c49_thisId.fParent = NULL;
  c49_y = c49_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c49_flag_lastWPT),
    &c49_thisId);
  sf_mex_destroy(&c49_flag_lastWPT);
  *(real_T *)c49_outData = c49_y;
  sf_mex_destroy(&c49_mxArrayInData);
}

static const mxArray *c49_b_sf_marshallOut(void *chartInstanceVoid, void
  *c49_inData)
{
  const mxArray *c49_mxArrayOutData = NULL;
  int32_T c49_i6;
  real_T c49_b_inData[2];
  int32_T c49_i7;
  real_T c49_u[2];
  const mxArray *c49_y = NULL;
  SFc49_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc49_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c49_mxArrayOutData = NULL;
  for (c49_i6 = 0; c49_i6 < 2; c49_i6++) {
    c49_b_inData[c49_i6] = (*(real_T (*)[2])c49_inData)[c49_i6];
  }

  for (c49_i7 = 0; c49_i7 < 2; c49_i7++) {
    c49_u[c49_i7] = c49_b_inData[c49_i7];
  }

  c49_y = NULL;
  sf_mex_assign(&c49_y, sf_mex_create("y", c49_u, 0, 0U, 1U, 0U, 1, 2));
  sf_mex_assign(&c49_mxArrayOutData, c49_y);
  return c49_mxArrayOutData;
}

static const mxArray *c49_c_sf_marshallOut(void *chartInstanceVoid, void
  *c49_inData)
{
  const mxArray *c49_mxArrayOutData = NULL;
  int32_T c49_i8;
  real_T c49_b_inData[31];
  int32_T c49_i9;
  real_T c49_u[31];
  const mxArray *c49_y = NULL;
  SFc49_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc49_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c49_mxArrayOutData = NULL;
  for (c49_i8 = 0; c49_i8 < 31; c49_i8++) {
    c49_b_inData[c49_i8] = (*(real_T (*)[31])c49_inData)[c49_i8];
  }

  for (c49_i9 = 0; c49_i9 < 31; c49_i9++) {
    c49_u[c49_i9] = c49_b_inData[c49_i9];
  }

  c49_y = NULL;
  sf_mex_assign(&c49_y, sf_mex_create("y", c49_u, 0, 0U, 1U, 0U, 1, 31));
  sf_mex_assign(&c49_mxArrayOutData, c49_y);
  return c49_mxArrayOutData;
}

const mxArray *sf_c49_ACX_Simulator_get_eml_resolved_functions_info(void)
{
  const mxArray *c49_nameCaptureInfo;
  c49_ResolvedFunctionInfo c49_info[16];
  const mxArray *c49_m0 = NULL;
  int32_T c49_i10;
  c49_ResolvedFunctionInfo *c49_r0;
  c49_nameCaptureInfo = NULL;
  c49_nameCaptureInfo = NULL;
  c49_info_helper(c49_info);
  sf_mex_assign(&c49_m0, sf_mex_createstruct("nameCaptureInfo", 1, 16));
  for (c49_i10 = 0; c49_i10 < 16; c49_i10++) {
    c49_r0 = &c49_info[c49_i10];
    sf_mex_addfield(c49_m0, sf_mex_create("nameCaptureInfo", c49_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c49_r0->context)), "context", "nameCaptureInfo",
                    c49_i10);
    sf_mex_addfield(c49_m0, sf_mex_create("nameCaptureInfo", c49_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c49_r0->name)), "name", "nameCaptureInfo",
                    c49_i10);
    sf_mex_addfield(c49_m0, sf_mex_create("nameCaptureInfo",
      c49_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c49_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c49_i10);
    sf_mex_addfield(c49_m0, sf_mex_create("nameCaptureInfo", c49_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c49_r0->resolved)), "resolved",
                    "nameCaptureInfo", c49_i10);
    sf_mex_addfield(c49_m0, sf_mex_create("nameCaptureInfo", &c49_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c49_i10);
    sf_mex_addfield(c49_m0, sf_mex_create("nameCaptureInfo", &c49_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c49_i10);
    sf_mex_addfield(c49_m0, sf_mex_create("nameCaptureInfo",
      &c49_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c49_i10);
    sf_mex_addfield(c49_m0, sf_mex_create("nameCaptureInfo",
      &c49_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c49_i10);
  }

  sf_mex_assign(&c49_nameCaptureInfo, c49_m0);
  return c49_nameCaptureInfo;
}

static void c49_info_helper(c49_ResolvedFunctionInfo c49_info[16])
{
  c49_info[0].context = "";
  c49_info[0].name = "length";
  c49_info[0].dominantType = "double";
  c49_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/length.m";
  c49_info[0].fileTimeLo = 1286818760U;
  c49_info[0].fileTimeHi = 0U;
  c49_info[0].mFileTimeLo = 0U;
  c49_info[0].mFileTimeHi = 0U;
  c49_info[1].context = "";
  c49_info[1].name = "cos";
  c49_info[1].dominantType = "double";
  c49_info[1].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c49_info[1].fileTimeLo = 1286818706U;
  c49_info[1].fileTimeHi = 0U;
  c49_info[1].mFileTimeLo = 0U;
  c49_info[1].mFileTimeHi = 0U;
  c49_info[2].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c49_info[2].name = "eml_scalar_cos";
  c49_info[2].dominantType = "double";
  c49_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c49_info[2].fileTimeLo = 1286818722U;
  c49_info[2].fileTimeHi = 0U;
  c49_info[2].mFileTimeLo = 0U;
  c49_info[2].mFileTimeHi = 0U;
  c49_info[3].context = "";
  c49_info[3].name = "mtimes";
  c49_info[3].dominantType = "double";
  c49_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c49_info[3].fileTimeLo = 1289519692U;
  c49_info[3].fileTimeHi = 0U;
  c49_info[3].mFileTimeLo = 0U;
  c49_info[3].mFileTimeHi = 0U;
  c49_info[4].context = "";
  c49_info[4].name = "sin";
  c49_info[4].dominantType = "double";
  c49_info[4].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c49_info[4].fileTimeLo = 1286818750U;
  c49_info[4].fileTimeHi = 0U;
  c49_info[4].mFileTimeLo = 0U;
  c49_info[4].mFileTimeHi = 0U;
  c49_info[5].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c49_info[5].name = "eml_scalar_sin";
  c49_info[5].dominantType = "double";
  c49_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c49_info[5].fileTimeLo = 1286818736U;
  c49_info[5].fileTimeHi = 0U;
  c49_info[5].mFileTimeLo = 0U;
  c49_info[5].mFileTimeHi = 0U;
  c49_info[6].context = "";
  c49_info[6].name = "mpower";
  c49_info[6].dominantType = "double";
  c49_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c49_info[6].fileTimeLo = 1286818842U;
  c49_info[6].fileTimeHi = 0U;
  c49_info[6].mFileTimeLo = 0U;
  c49_info[6].mFileTimeHi = 0U;
  c49_info[7].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c49_info[7].name = "power";
  c49_info[7].dominantType = "double";
  c49_info[7].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c49_info[7].fileTimeLo = 1286818844U;
  c49_info[7].fileTimeHi = 0U;
  c49_info[7].mFileTimeLo = 0U;
  c49_info[7].mFileTimeHi = 0U;
  c49_info[8].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c49_info[8].name = "eml_scalar_eg";
  c49_info[8].dominantType = "double";
  c49_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c49_info[8].fileTimeLo = 1286818796U;
  c49_info[8].fileTimeHi = 0U;
  c49_info[8].mFileTimeLo = 0U;
  c49_info[8].mFileTimeHi = 0U;
  c49_info[9].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c49_info[9].name = "eml_scalexp_alloc";
  c49_info[9].dominantType = "double";
  c49_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c49_info[9].fileTimeLo = 1286818796U;
  c49_info[9].fileTimeHi = 0U;
  c49_info[9].mFileTimeLo = 0U;
  c49_info[9].mFileTimeHi = 0U;
  c49_info[10].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c49_info[10].name = "eml_scalar_floor";
  c49_info[10].dominantType = "double";
  c49_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c49_info[10].fileTimeLo = 1286818726U;
  c49_info[10].fileTimeHi = 0U;
  c49_info[10].mFileTimeLo = 0U;
  c49_info[10].mFileTimeHi = 0U;
  c49_info[11].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c49_info[11].name = "eml_error";
  c49_info[11].dominantType = "char";
  c49_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  c49_info[11].fileTimeLo = 1286818700U;
  c49_info[11].fileTimeHi = 0U;
  c49_info[11].mFileTimeLo = 0U;
  c49_info[11].mFileTimeHi = 0U;
  c49_info[12].context = "";
  c49_info[12].name = "sqrt";
  c49_info[12].dominantType = "double";
  c49_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c49_info[12].fileTimeLo = 1286818752U;
  c49_info[12].fileTimeHi = 0U;
  c49_info[12].mFileTimeLo = 0U;
  c49_info[12].mFileTimeHi = 0U;
  c49_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c49_info[13].name = "eml_scalar_sqrt";
  c49_info[13].dominantType = "double";
  c49_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m";
  c49_info[13].fileTimeLo = 1286818738U;
  c49_info[13].fileTimeHi = 0U;
  c49_info[13].mFileTimeLo = 0U;
  c49_info[13].mFileTimeHi = 0U;
  c49_info[14].context = "";
  c49_info[14].name = "atan2";
  c49_info[14].dominantType = "double";
  c49_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c49_info[14].fileTimeLo = 1286818704U;
  c49_info[14].fileTimeHi = 0U;
  c49_info[14].mFileTimeLo = 0U;
  c49_info[14].mFileTimeHi = 0U;
  c49_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/atan2.m";
  c49_info[15].name = "eml_scalar_atan2";
  c49_info[15].dominantType = "double";
  c49_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_atan2.m";
  c49_info[15].fileTimeLo = 1286818720U;
  c49_info[15].fileTimeHi = 0U;
  c49_info[15].mFileTimeLo = 0U;
  c49_info[15].mFileTimeHi = 0U;
}

static real_T c49_mpower(SFc49_ACX_SimulatorInstanceStruct *chartInstance,
  real_T c49_a)
{
  real_T c49_b_a;
  real_T c49_ak;
  c49_b_a = c49_a;
  c49_eml_scalar_eg(chartInstance);
  c49_ak = c49_b_a;
  return muDoubleScalarPower(c49_ak, 2.0);
}

static void c49_eml_scalar_eg(SFc49_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static void c49_eml_error(SFc49_ACX_SimulatorInstanceStruct *chartInstance)
{
  int32_T c49_i11;
  static char_T c49_varargin_1[30] = { 'C', 'o', 'd', 'e', 'r', ':', 't', 'o',
    'o', 'l', 'b', 'o', 'x', ':', 's', 'q', 'r', 't', '_', 'd', 'o', 'm', 'a',
    'i', 'n', 'E', 'r', 'r', 'o', 'r' };

  char_T c49_u[30];
  const mxArray *c49_y = NULL;
  for (c49_i11 = 0; c49_i11 < 30; c49_i11++) {
    c49_u[c49_i11] = c49_varargin_1[c49_i11];
  }

  c49_y = NULL;
  sf_mex_assign(&c49_y, sf_mex_create("y", c49_u, 10, 0U, 1U, 0U, 2, 1, 30));
  sf_mex_call_debug("error", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U, 14,
    c49_y));
}

static const mxArray *c49_d_sf_marshallOut(void *chartInstanceVoid, void
  *c49_inData)
{
  const mxArray *c49_mxArrayOutData = NULL;
  int32_T c49_u;
  const mxArray *c49_y = NULL;
  SFc49_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc49_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c49_mxArrayOutData = NULL;
  c49_u = *(int32_T *)c49_inData;
  c49_y = NULL;
  sf_mex_assign(&c49_y, sf_mex_create("y", &c49_u, 6, 0U, 0U, 0U, 0));
  sf_mex_assign(&c49_mxArrayOutData, c49_y);
  return c49_mxArrayOutData;
}

static int32_T c49_c_emlrt_marshallIn(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c49_u, const emlrtMsgIdentifier *c49_parentId)
{
  int32_T c49_y;
  int32_T c49_i12;
  sf_mex_import(c49_parentId, sf_mex_dup(c49_u), &c49_i12, 1, 6, 0U, 0, 0U, 0);
  c49_y = c49_i12;
  sf_mex_destroy(&c49_u);
  return c49_y;
}

static void c49_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c49_mxArrayInData, const char_T *c49_varName, void *c49_outData)
{
  const mxArray *c49_b_sfEvent;
  const char_T *c49_identifier;
  emlrtMsgIdentifier c49_thisId;
  int32_T c49_y;
  SFc49_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc49_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c49_b_sfEvent = sf_mex_dup(c49_mxArrayInData);
  c49_identifier = c49_varName;
  c49_thisId.fIdentifier = c49_identifier;
  c49_thisId.fParent = NULL;
  c49_y = c49_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c49_b_sfEvent),
    &c49_thisId);
  sf_mex_destroy(&c49_b_sfEvent);
  *(int32_T *)c49_outData = c49_y;
  sf_mex_destroy(&c49_mxArrayInData);
}

static uint8_T c49_d_emlrt_marshallIn(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c49_b_is_active_c49_ACX_Simulator, const char_T
  *c49_identifier)
{
  uint8_T c49_y;
  emlrtMsgIdentifier c49_thisId;
  c49_thisId.fIdentifier = c49_identifier;
  c49_thisId.fParent = NULL;
  c49_y = c49_e_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c49_b_is_active_c49_ACX_Simulator), &c49_thisId);
  sf_mex_destroy(&c49_b_is_active_c49_ACX_Simulator);
  return c49_y;
}

static uint8_T c49_e_emlrt_marshallIn(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c49_u, const emlrtMsgIdentifier *c49_parentId)
{
  uint8_T c49_y;
  uint8_T c49_u0;
  sf_mex_import(c49_parentId, sf_mex_dup(c49_u), &c49_u0, 1, 3, 0U, 0, 0U, 0);
  c49_y = c49_u0;
  sf_mex_destroy(&c49_u);
  return c49_y;
}

static void init_dsm_address_info(SFc49_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c49_ACX_Simulator_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2108189843U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2773374823U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1943677169U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1352591915U);
}

mxArray *sf_c49_ACX_Simulator_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(20548460U);
    pr[1] = (double)(4001348499U);
    pr[2] = (double)(895739736U);
    pr[3] = (double)(987425927U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,10,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(31);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(31);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }

    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,8,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }

    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,9,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,9,"type",mxType);
    }

    mxSetField(mxData,9,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,8,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }

    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c49_ACX_Simulator(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x9'type','srcId','name','auxInfo'{{M[1],M[5],T\"X_WPT_OUT\",},{M[1],M[10],T\"Y_WPT_OUT\",},{M[1],M[12],T\"counter_out\",},{M[1],M[22],T\"dista\",},{M[1],M[23],T\"flag_lastWPT\",},{M[1],M[11],T\"heading\",},{M[1],M[20],T\"initFLAG_out\",},{M[1],M[16],T\"stopFlag\",},{M[8],M[0],T\"is_active_c49_ACX_Simulator\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 9, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c49_ACX_Simulator_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc49_ACX_SimulatorInstanceStruct *chartInstance;
    chartInstance = (SFc49_ACX_SimulatorInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ACX_SimulatorMachineNumber_,
           49,
           1,
           1,
           18,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_ACX_SimulatorMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"X_WPTs");
          _SFD_SET_DATA_PROPS(1,2,0,1,"X_WPT_OUT");
          _SFD_SET_DATA_PROPS(2,1,1,0,"Y_WPTs");
          _SFD_SET_DATA_PROPS(3,1,1,0,"XY_MEAS");
          _SFD_SET_DATA_PROPS(4,1,1,0,"counter");
          _SFD_SET_DATA_PROPS(5,1,1,0,"dist_thres");
          _SFD_SET_DATA_PROPS(6,2,0,1,"Y_WPT_OUT");
          _SFD_SET_DATA_PROPS(7,2,0,1,"heading");
          _SFD_SET_DATA_PROPS(8,2,0,1,"counter_out");
          _SFD_SET_DATA_PROPS(9,1,1,0,"X_WPT_CUR");
          _SFD_SET_DATA_PROPS(10,1,1,0,"Y_WPT_CUR");
          _SFD_SET_DATA_PROPS(11,1,1,0,"heading_prev");
          _SFD_SET_DATA_PROPS(12,2,0,1,"stopFlag");
          _SFD_SET_DATA_PROPS(13,1,1,0,"SM_FLAG");
          _SFD_SET_DATA_PROPS(14,1,1,0,"initFLAG");
          _SFD_SET_DATA_PROPS(15,2,0,1,"initFLAG_out");
          _SFD_SET_DATA_PROPS(16,2,0,1,"dista");
          _SFD_SET_DATA_PROPS(17,2,0,1,"flag_lastWPT");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,7,0,0,0,0,8,4);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,1737);
        _SFD_CV_INIT_EML_IF(0,0,709,748,-1,774);
        _SFD_CV_INIT_EML_IF(0,1,776,815,-1,889);
        _SFD_CV_INIT_EML_IF(0,2,891,928,-1,1006);
        _SFD_CV_INIT_EML_IF(0,3,1026,1045,-1,1071);
        _SFD_CV_INIT_EML_IF(0,4,1112,1150,1647,1709);
        _SFD_CV_INIT_EML_IF(0,5,1182,1198,1233,1272);
        _SFD_CV_INIT_EML_IF(0,6,1278,1305,1572,1646);

        {
          static int condStart[] = { 713, 729 };

          static int condEnd[] = { 725, 746 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,0,712,747,2,0,&(condStart[0]),&(condEnd[0]),3,
                                &(pfixExpr[0]));
        }

        {
          static int condStart[] = { 780, 796 };

          static int condEnd[] = { 792, 813 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,779,814,2,2,&(condStart[0]),&(condEnd[0]),3,
                                &(pfixExpr[0]));
        }

        {
          static int condStart[] = { 895, 909 };

          static int condEnd[] = { 905, 926 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,2,894,927,2,4,&(condStart[0]),&(condEnd[0]),3,
                                &(pfixExpr[0]));
        }

        {
          static int condStart[] = { 1116, 1137 };

          static int condEnd[] = { 1133, 1148 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,3,1115,1149,2,6,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 31;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c49_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c49_sf_marshallOut,(MexInFcnForType)c49_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 31;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c49_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 2;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c49_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c49_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c49_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c49_sf_marshallOut,(MexInFcnForType)c49_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c49_sf_marshallOut,(MexInFcnForType)c49_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c49_sf_marshallOut,(MexInFcnForType)c49_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c49_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(10,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c49_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(11,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c49_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(12,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c49_sf_marshallOut,(MexInFcnForType)c49_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(13,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c49_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(14,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c49_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(15,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c49_sf_marshallOut,(MexInFcnForType)c49_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(16,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c49_sf_marshallOut,(MexInFcnForType)c49_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(17,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c49_sf_marshallOut,(MexInFcnForType)c49_sf_marshallIn);

        {
          real_T *c49_X_WPT_OUT;
          real_T *c49_counter;
          real_T *c49_dist_thres;
          real_T *c49_Y_WPT_OUT;
          real_T *c49_heading;
          real_T *c49_counter_out;
          real_T *c49_X_WPT_CUR;
          real_T *c49_Y_WPT_CUR;
          real_T *c49_heading_prev;
          real_T *c49_stopFlag;
          real_T *c49_SM_FLAG;
          real_T *c49_initFLAG;
          real_T *c49_initFLAG_out;
          real_T *c49_dista;
          real_T *c49_flag_lastWPT;
          real_T (*c49_X_WPTs)[31];
          real_T (*c49_Y_WPTs)[31];
          real_T (*c49_XY_MEAS)[2];
          c49_flag_lastWPT = (real_T *)ssGetOutputPortSignal(chartInstance->S, 8);
          c49_dista = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
          c49_initFLAG_out = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
          c49_initFLAG = (real_T *)ssGetInputPortSignal(chartInstance->S, 9);
          c49_SM_FLAG = (real_T *)ssGetInputPortSignal(chartInstance->S, 8);
          c49_stopFlag = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
          c49_heading_prev = (real_T *)ssGetInputPortSignal(chartInstance->S, 7);
          c49_Y_WPT_CUR = (real_T *)ssGetInputPortSignal(chartInstance->S, 6);
          c49_X_WPT_CUR = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
          c49_counter_out = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
          c49_heading = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c49_Y_WPT_OUT = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c49_dist_thres = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
          c49_counter = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c49_XY_MEAS = (real_T (*)[2])ssGetInputPortSignal(chartInstance->S, 2);
          c49_Y_WPTs = (real_T (*)[31])ssGetInputPortSignal(chartInstance->S, 1);
          c49_X_WPT_OUT = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c49_X_WPTs = (real_T (*)[31])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c49_X_WPTs);
          _SFD_SET_DATA_VALUE_PTR(1U, c49_X_WPT_OUT);
          _SFD_SET_DATA_VALUE_PTR(2U, *c49_Y_WPTs);
          _SFD_SET_DATA_VALUE_PTR(3U, *c49_XY_MEAS);
          _SFD_SET_DATA_VALUE_PTR(4U, c49_counter);
          _SFD_SET_DATA_VALUE_PTR(5U, c49_dist_thres);
          _SFD_SET_DATA_VALUE_PTR(6U, c49_Y_WPT_OUT);
          _SFD_SET_DATA_VALUE_PTR(7U, c49_heading);
          _SFD_SET_DATA_VALUE_PTR(8U, c49_counter_out);
          _SFD_SET_DATA_VALUE_PTR(9U, c49_X_WPT_CUR);
          _SFD_SET_DATA_VALUE_PTR(10U, c49_Y_WPT_CUR);
          _SFD_SET_DATA_VALUE_PTR(11U, c49_heading_prev);
          _SFD_SET_DATA_VALUE_PTR(12U, c49_stopFlag);
          _SFD_SET_DATA_VALUE_PTR(13U, c49_SM_FLAG);
          _SFD_SET_DATA_VALUE_PTR(14U, c49_initFLAG);
          _SFD_SET_DATA_VALUE_PTR(15U, c49_initFLAG_out);
          _SFD_SET_DATA_VALUE_PTR(16U, c49_dista);
          _SFD_SET_DATA_VALUE_PTR(17U, c49_flag_lastWPT);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ACX_SimulatorMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c49_ACX_Simulator(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc49_ACX_SimulatorInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c49_ACX_Simulator((SFc49_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
  initialize_c49_ACX_Simulator((SFc49_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c49_ACX_Simulator(void *chartInstanceVar)
{
  enable_c49_ACX_Simulator((SFc49_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c49_ACX_Simulator(void *chartInstanceVar)
{
  disable_c49_ACX_Simulator((SFc49_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c49_ACX_Simulator(void *chartInstanceVar)
{
  sf_c49_ACX_Simulator((SFc49_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c49_ACX_Simulator(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c49_ACX_Simulator
    ((SFc49_ACX_SimulatorInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c49_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c49_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c49_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c49_ACX_Simulator((SFc49_ACX_SimulatorInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c49_ACX_Simulator(SimStruct* S)
{
  return sf_internal_get_sim_state_c49_ACX_Simulator(S);
}

static void sf_opaque_set_sim_state_c49_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  sf_internal_set_sim_state_c49_ACX_Simulator(S, st);
}

static void sf_opaque_terminate_c49_ACX_Simulator(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc49_ACX_SimulatorInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c49_ACX_Simulator((SFc49_ACX_SimulatorInstanceStruct*)
      chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc49_ACX_Simulator((SFc49_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c49_ACX_Simulator(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c49_ACX_Simulator((SFc49_ACX_SimulatorInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c49_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,"ACX_Simulator","ACX_Simulator",49);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,"ACX_Simulator","ACX_Simulator",49,
                "RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,"ACX_Simulator",
      "ACX_Simulator",49,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 6, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 7, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 8, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 9, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"ACX_Simulator","ACX_Simulator",49,
        10);
      sf_mark_chart_reusable_outputs(S,"ACX_Simulator","ACX_Simulator",49,8);
    }

    sf_set_rtw_dwork_info(S,"ACX_Simulator","ACX_Simulator",49);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2368581710U));
  ssSetChecksum1(S,(1181965031U));
  ssSetChecksum2(S,(2739963883U));
  ssSetChecksum3(S,(870641022U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c49_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "ACX_Simulator", "ACX_Simulator",49);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c49_ACX_Simulator(SimStruct *S)
{
  SFc49_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc49_ACX_SimulatorInstanceStruct *)malloc(sizeof
    (SFc49_ACX_SimulatorInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc49_ACX_SimulatorInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c49_ACX_Simulator;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c49_ACX_Simulator;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c49_ACX_Simulator;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c49_ACX_Simulator;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c49_ACX_Simulator;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c49_ACX_Simulator;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c49_ACX_Simulator;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c49_ACX_Simulator;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c49_ACX_Simulator;
  chartInstance->chartInfo.mdlStart = mdlStart_c49_ACX_Simulator;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c49_ACX_Simulator;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c49_ACX_Simulator_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c49_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c49_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c49_ACX_Simulator(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c49_ACX_Simulator_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
