/* Include files */

#include "blascompat32.h"
#include "ACX_Simulator_sfun.h"
#include "c55_ACX_Simulator.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "ACX_Simulator_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char * c55_debug_family_names[10] = { "dist_reversed", "delta_vel",
  "nargin", "nargout", "Vel_Ref", "distanceToWPT", "ThresholdDist",
  "MaxDeltaVel", "flagLastWPT", "Vel_Ref_Out" };

/* Function Declarations */
static void initialize_c55_ACX_Simulator(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initialize_params_c55_ACX_Simulator
  (SFc55_ACX_SimulatorInstanceStruct *chartInstance);
static void enable_c55_ACX_Simulator(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance);
static void disable_c55_ACX_Simulator(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance);
static void c55_update_debugger_state_c55_ACX_Simulator
  (SFc55_ACX_SimulatorInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c55_ACX_Simulator
  (SFc55_ACX_SimulatorInstanceStruct *chartInstance);
static void set_sim_state_c55_ACX_Simulator(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c55_st);
static void finalize_c55_ACX_Simulator(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance);
static void sf_c55_ACX_Simulator(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance);
static void initSimStructsc55_ACX_Simulator(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c55_machineNumber, uint32_T
  c55_chartNumber);
static const mxArray *c55_sf_marshallOut(void *chartInstanceVoid, void
  *c55_inData);
static real_T c55_emlrt_marshallIn(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c55_Vel_Ref_Out, const char_T *c55_identifier);
static real_T c55_b_emlrt_marshallIn(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c55_u, const emlrtMsgIdentifier *c55_parentId);
static void c55_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c55_mxArrayInData, const char_T *c55_varName, void *c55_outData);
static const mxArray *c55_b_sf_marshallOut(void *chartInstanceVoid, void
  *c55_inData);
static int32_T c55_c_emlrt_marshallIn(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c55_u, const emlrtMsgIdentifier *c55_parentId);
static void c55_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c55_mxArrayInData, const char_T *c55_varName, void *c55_outData);
static uint8_T c55_d_emlrt_marshallIn(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c55_b_is_active_c55_ACX_Simulator, const char_T
  *c55_identifier);
static uint8_T c55_e_emlrt_marshallIn(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c55_u, const emlrtMsgIdentifier *c55_parentId);
static void init_dsm_address_info(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c55_ACX_Simulator(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  chartInstance->c55_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c55_is_active_c55_ACX_Simulator = 0U;
}

static void initialize_params_c55_ACX_Simulator
  (SFc55_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static void enable_c55_ACX_Simulator(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c55_ACX_Simulator(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c55_update_debugger_state_c55_ACX_Simulator
  (SFc55_ACX_SimulatorInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c55_ACX_Simulator
  (SFc55_ACX_SimulatorInstanceStruct *chartInstance)
{
  const mxArray *c55_st;
  const mxArray *c55_y = NULL;
  real_T c55_hoistedGlobal;
  real_T c55_u;
  const mxArray *c55_b_y = NULL;
  uint8_T c55_b_hoistedGlobal;
  uint8_T c55_b_u;
  const mxArray *c55_c_y = NULL;
  real_T *c55_Vel_Ref_Out;
  c55_Vel_Ref_Out = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c55_st = NULL;
  c55_st = NULL;
  c55_y = NULL;
  sf_mex_assign(&c55_y, sf_mex_createcellarray(2));
  c55_hoistedGlobal = *c55_Vel_Ref_Out;
  c55_u = c55_hoistedGlobal;
  c55_b_y = NULL;
  sf_mex_assign(&c55_b_y, sf_mex_create("y", &c55_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c55_y, 0, c55_b_y);
  c55_b_hoistedGlobal = chartInstance->c55_is_active_c55_ACX_Simulator;
  c55_b_u = c55_b_hoistedGlobal;
  c55_c_y = NULL;
  sf_mex_assign(&c55_c_y, sf_mex_create("y", &c55_b_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c55_y, 1, c55_c_y);
  sf_mex_assign(&c55_st, c55_y);
  return c55_st;
}

static void set_sim_state_c55_ACX_Simulator(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c55_st)
{
  const mxArray *c55_u;
  real_T *c55_Vel_Ref_Out;
  c55_Vel_Ref_Out = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c55_doneDoubleBufferReInit = TRUE;
  c55_u = sf_mex_dup(c55_st);
  *c55_Vel_Ref_Out = c55_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c55_u, 0)), "Vel_Ref_Out");
  chartInstance->c55_is_active_c55_ACX_Simulator = c55_d_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c55_u, 1)),
     "is_active_c55_ACX_Simulator");
  sf_mex_destroy(&c55_u);
  c55_update_debugger_state_c55_ACX_Simulator(chartInstance);
  sf_mex_destroy(&c55_st);
}

static void finalize_c55_ACX_Simulator(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void sf_c55_ACX_Simulator(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance)
{
  real_T c55_hoistedGlobal;
  real_T c55_b_hoistedGlobal;
  real_T c55_c_hoistedGlobal;
  real_T c55_d_hoistedGlobal;
  real_T c55_e_hoistedGlobal;
  real_T c55_Vel_Ref;
  real_T c55_distanceToWPT;
  real_T c55_ThresholdDist;
  real_T c55_MaxDeltaVel;
  real_T c55_flagLastWPT;
  uint32_T c55_debug_family_var_map[10];
  real_T c55_dist_reversed;
  real_T c55_delta_vel;
  real_T c55_nargin = 5.0;
  real_T c55_nargout = 1.0;
  real_T c55_Vel_Ref_Out;
  real_T c55_A;
  real_T c55_B;
  real_T c55_x;
  real_T c55_y;
  real_T c55_b_x;
  real_T c55_b_y;
  real_T c55_c_x;
  real_T c55_c_y;
  real_T c55_d_y;
  real_T c55_a;
  real_T c55_b;
  real_T *c55_b_Vel_Ref;
  real_T *c55_b_Vel_Ref_Out;
  real_T *c55_b_distanceToWPT;
  real_T *c55_b_ThresholdDist;
  real_T *c55_b_MaxDeltaVel;
  real_T *c55_b_flagLastWPT;
  c55_b_flagLastWPT = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c55_b_MaxDeltaVel = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c55_b_ThresholdDist = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c55_b_distanceToWPT = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c55_b_Vel_Ref_Out = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c55_b_Vel_Ref = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 53U, chartInstance->c55_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c55_b_Vel_Ref, 0U);
  _SFD_DATA_RANGE_CHECK(*c55_b_Vel_Ref_Out, 1U);
  _SFD_DATA_RANGE_CHECK(*c55_b_distanceToWPT, 2U);
  _SFD_DATA_RANGE_CHECK(*c55_b_ThresholdDist, 3U);
  _SFD_DATA_RANGE_CHECK(*c55_b_MaxDeltaVel, 4U);
  _SFD_DATA_RANGE_CHECK(*c55_b_flagLastWPT, 5U);
  chartInstance->c55_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 53U, chartInstance->c55_sfEvent);
  c55_hoistedGlobal = *c55_b_Vel_Ref;
  c55_b_hoistedGlobal = *c55_b_distanceToWPT;
  c55_c_hoistedGlobal = *c55_b_ThresholdDist;
  c55_d_hoistedGlobal = *c55_b_MaxDeltaVel;
  c55_e_hoistedGlobal = *c55_b_flagLastWPT;
  c55_Vel_Ref = c55_hoistedGlobal;
  c55_distanceToWPT = c55_b_hoistedGlobal;
  c55_ThresholdDist = c55_c_hoistedGlobal;
  c55_MaxDeltaVel = c55_d_hoistedGlobal;
  c55_flagLastWPT = c55_e_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 10U, 10U, c55_debug_family_names,
    c55_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c55_dist_reversed, 0U,
    c55_sf_marshallOut, c55_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c55_delta_vel, 1U,
    c55_sf_marshallOut, c55_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c55_nargin, 2U, c55_sf_marshallOut,
    c55_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c55_nargout, 3U, c55_sf_marshallOut,
    c55_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c55_Vel_Ref, 4U, c55_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c55_distanceToWPT, 5U, c55_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c55_ThresholdDist, 6U, c55_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c55_MaxDeltaVel, 7U, c55_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c55_flagLastWPT, 8U, c55_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c55_Vel_Ref_Out, 9U,
    c55_sf_marshallOut, c55_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c55_sfEvent, 4);
  c55_Vel_Ref_Out = c55_Vel_Ref;
  _SFD_EML_CALL(0U, chartInstance->c55_sfEvent, 6);
  if (CV_EML_IF(0, 0, c55_flagLastWPT == 1.0)) {
    _SFD_EML_CALL(0U, chartInstance->c55_sfEvent, 8);
    if (CV_EML_IF(0, 1, c55_distanceToWPT <= c55_ThresholdDist)) {
      _SFD_EML_CALL(0U, chartInstance->c55_sfEvent, 9);
      c55_dist_reversed = c55_ThresholdDist - c55_distanceToWPT;
      _SFD_EML_CALL(0U, chartInstance->c55_sfEvent, 10);
      c55_A = c55_dist_reversed;
      c55_B = c55_MaxDeltaVel;
      c55_x = c55_A;
      c55_y = c55_B;
      c55_b_x = c55_x;
      c55_b_y = c55_y;
      c55_c_x = c55_b_x;
      c55_c_y = c55_b_y;
      c55_d_y = c55_c_x / c55_c_y;
      c55_a = c55_MaxDeltaVel;
      c55_b = c55_d_y;
      c55_delta_vel = c55_a * c55_b;
      _SFD_EML_CALL(0U, chartInstance->c55_sfEvent, 11);
      c55_Vel_Ref_Out = c55_Vel_Ref - c55_delta_vel;
      _SFD_EML_CALL(0U, chartInstance->c55_sfEvent, 12);
      if (CV_EML_IF(0, 2, c55_Vel_Ref_Out < 0.0)) {
        _SFD_EML_CALL(0U, chartInstance->c55_sfEvent, 13);
        c55_Vel_Ref_Out = 0.0;
      }
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c55_sfEvent, -13);
  sf_debug_symbol_scope_pop();
  *c55_b_Vel_Ref_Out = c55_Vel_Ref_Out;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 53U, chartInstance->c55_sfEvent);
  sf_debug_check_for_state_inconsistency(_ACX_SimulatorMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc55_ACX_Simulator(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c55_machineNumber, uint32_T
  c55_chartNumber)
{
}

static const mxArray *c55_sf_marshallOut(void *chartInstanceVoid, void
  *c55_inData)
{
  const mxArray *c55_mxArrayOutData = NULL;
  real_T c55_u;
  const mxArray *c55_y = NULL;
  SFc55_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc55_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c55_mxArrayOutData = NULL;
  c55_u = *(real_T *)c55_inData;
  c55_y = NULL;
  sf_mex_assign(&c55_y, sf_mex_create("y", &c55_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c55_mxArrayOutData, c55_y);
  return c55_mxArrayOutData;
}

static real_T c55_emlrt_marshallIn(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c55_Vel_Ref_Out, const char_T *c55_identifier)
{
  real_T c55_y;
  emlrtMsgIdentifier c55_thisId;
  c55_thisId.fIdentifier = c55_identifier;
  c55_thisId.fParent = NULL;
  c55_y = c55_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c55_Vel_Ref_Out),
    &c55_thisId);
  sf_mex_destroy(&c55_Vel_Ref_Out);
  return c55_y;
}

static real_T c55_b_emlrt_marshallIn(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c55_u, const emlrtMsgIdentifier *c55_parentId)
{
  real_T c55_y;
  real_T c55_d0;
  sf_mex_import(c55_parentId, sf_mex_dup(c55_u), &c55_d0, 1, 0, 0U, 0, 0U, 0);
  c55_y = c55_d0;
  sf_mex_destroy(&c55_u);
  return c55_y;
}

static void c55_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c55_mxArrayInData, const char_T *c55_varName, void *c55_outData)
{
  const mxArray *c55_Vel_Ref_Out;
  const char_T *c55_identifier;
  emlrtMsgIdentifier c55_thisId;
  real_T c55_y;
  SFc55_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc55_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c55_Vel_Ref_Out = sf_mex_dup(c55_mxArrayInData);
  c55_identifier = c55_varName;
  c55_thisId.fIdentifier = c55_identifier;
  c55_thisId.fParent = NULL;
  c55_y = c55_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c55_Vel_Ref_Out),
    &c55_thisId);
  sf_mex_destroy(&c55_Vel_Ref_Out);
  *(real_T *)c55_outData = c55_y;
  sf_mex_destroy(&c55_mxArrayInData);
}

const mxArray *sf_c55_ACX_Simulator_get_eml_resolved_functions_info(void)
{
  const mxArray *c55_nameCaptureInfo;
  c55_ResolvedFunctionInfo c55_info[4];
  c55_ResolvedFunctionInfo (*c55_b_info)[4];
  const mxArray *c55_m0 = NULL;
  int32_T c55_i0;
  c55_ResolvedFunctionInfo *c55_r0;
  c55_nameCaptureInfo = NULL;
  c55_nameCaptureInfo = NULL;
  c55_b_info = (c55_ResolvedFunctionInfo (*)[4])c55_info;
  (*c55_b_info)[0].context = "";
  (*c55_b_info)[0].name = "mrdivide";
  (*c55_b_info)[0].dominantType = "double";
  (*c55_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c55_b_info)[0].fileTimeLo = 1296664654U;
  (*c55_b_info)[0].fileTimeHi = 0U;
  (*c55_b_info)[0].mFileTimeLo = 1289519692U;
  (*c55_b_info)[0].mFileTimeHi = 0U;
  (*c55_b_info)[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c55_b_info)[1].name = "rdivide";
  (*c55_b_info)[1].dominantType = "double";
  (*c55_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c55_b_info)[1].fileTimeLo = 1286818844U;
  (*c55_b_info)[1].fileTimeHi = 0U;
  (*c55_b_info)[1].mFileTimeLo = 0U;
  (*c55_b_info)[1].mFileTimeHi = 0U;
  (*c55_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c55_b_info)[2].name = "eml_div";
  (*c55_b_info)[2].dominantType = "double";
  (*c55_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c55_b_info)[2].fileTimeLo = 1286818698U;
  (*c55_b_info)[2].fileTimeHi = 0U;
  (*c55_b_info)[2].mFileTimeLo = 0U;
  (*c55_b_info)[2].mFileTimeHi = 0U;
  (*c55_b_info)[3].context = "";
  (*c55_b_info)[3].name = "mtimes";
  (*c55_b_info)[3].dominantType = "double";
  (*c55_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c55_b_info)[3].fileTimeLo = 1289519692U;
  (*c55_b_info)[3].fileTimeHi = 0U;
  (*c55_b_info)[3].mFileTimeLo = 0U;
  (*c55_b_info)[3].mFileTimeHi = 0U;
  sf_mex_assign(&c55_m0, sf_mex_createstruct("nameCaptureInfo", 1, 4));
  for (c55_i0 = 0; c55_i0 < 4; c55_i0++) {
    c55_r0 = &c55_info[c55_i0];
    sf_mex_addfield(c55_m0, sf_mex_create("nameCaptureInfo", c55_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c55_r0->context)), "context", "nameCaptureInfo",
                    c55_i0);
    sf_mex_addfield(c55_m0, sf_mex_create("nameCaptureInfo", c55_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c55_r0->name)), "name", "nameCaptureInfo", c55_i0);
    sf_mex_addfield(c55_m0, sf_mex_create("nameCaptureInfo",
      c55_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c55_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c55_i0);
    sf_mex_addfield(c55_m0, sf_mex_create("nameCaptureInfo", c55_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c55_r0->resolved)), "resolved",
                    "nameCaptureInfo", c55_i0);
    sf_mex_addfield(c55_m0, sf_mex_create("nameCaptureInfo", &c55_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c55_i0);
    sf_mex_addfield(c55_m0, sf_mex_create("nameCaptureInfo", &c55_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c55_i0);
    sf_mex_addfield(c55_m0, sf_mex_create("nameCaptureInfo",
      &c55_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c55_i0);
    sf_mex_addfield(c55_m0, sf_mex_create("nameCaptureInfo",
      &c55_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c55_i0);
  }

  sf_mex_assign(&c55_nameCaptureInfo, c55_m0);
  return c55_nameCaptureInfo;
}

static const mxArray *c55_b_sf_marshallOut(void *chartInstanceVoid, void
  *c55_inData)
{
  const mxArray *c55_mxArrayOutData = NULL;
  int32_T c55_u;
  const mxArray *c55_y = NULL;
  SFc55_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc55_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c55_mxArrayOutData = NULL;
  c55_u = *(int32_T *)c55_inData;
  c55_y = NULL;
  sf_mex_assign(&c55_y, sf_mex_create("y", &c55_u, 6, 0U, 0U, 0U, 0));
  sf_mex_assign(&c55_mxArrayOutData, c55_y);
  return c55_mxArrayOutData;
}

static int32_T c55_c_emlrt_marshallIn(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c55_u, const emlrtMsgIdentifier *c55_parentId)
{
  int32_T c55_y;
  int32_T c55_i1;
  sf_mex_import(c55_parentId, sf_mex_dup(c55_u), &c55_i1, 1, 6, 0U, 0, 0U, 0);
  c55_y = c55_i1;
  sf_mex_destroy(&c55_u);
  return c55_y;
}

static void c55_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c55_mxArrayInData, const char_T *c55_varName, void *c55_outData)
{
  const mxArray *c55_b_sfEvent;
  const char_T *c55_identifier;
  emlrtMsgIdentifier c55_thisId;
  int32_T c55_y;
  SFc55_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc55_ACX_SimulatorInstanceStruct *)chartInstanceVoid;
  c55_b_sfEvent = sf_mex_dup(c55_mxArrayInData);
  c55_identifier = c55_varName;
  c55_thisId.fIdentifier = c55_identifier;
  c55_thisId.fParent = NULL;
  c55_y = c55_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c55_b_sfEvent),
    &c55_thisId);
  sf_mex_destroy(&c55_b_sfEvent);
  *(int32_T *)c55_outData = c55_y;
  sf_mex_destroy(&c55_mxArrayInData);
}

static uint8_T c55_d_emlrt_marshallIn(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c55_b_is_active_c55_ACX_Simulator, const char_T
  *c55_identifier)
{
  uint8_T c55_y;
  emlrtMsgIdentifier c55_thisId;
  c55_thisId.fIdentifier = c55_identifier;
  c55_thisId.fParent = NULL;
  c55_y = c55_e_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c55_b_is_active_c55_ACX_Simulator), &c55_thisId);
  sf_mex_destroy(&c55_b_is_active_c55_ACX_Simulator);
  return c55_y;
}

static uint8_T c55_e_emlrt_marshallIn(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance, const mxArray *c55_u, const emlrtMsgIdentifier *c55_parentId)
{
  uint8_T c55_y;
  uint8_T c55_u0;
  sf_mex_import(c55_parentId, sf_mex_dup(c55_u), &c55_u0, 1, 3, 0U, 0, 0U, 0);
  c55_y = c55_u0;
  sf_mex_destroy(&c55_u);
  return c55_y;
}

static void init_dsm_address_info(SFc55_ACX_SimulatorInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c55_ACX_Simulator_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(446387706U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(964855149U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(225266677U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(192110896U);
}

mxArray *sf_c55_ACX_Simulator_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(2779991465U);
    pr[1] = (double)(3525698653U);
    pr[2] = (double)(2971291476U);
    pr[3] = (double)(1878872232U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,5,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c55_ACX_Simulator(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"Vel_Ref_Out\",},{M[8],M[0],T\"is_active_c55_ACX_Simulator\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c55_ACX_Simulator_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc55_ACX_SimulatorInstanceStruct *chartInstance;
    chartInstance = (SFc55_ACX_SimulatorInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ACX_SimulatorMachineNumber_,
           55,
           1,
           1,
           6,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_ACX_SimulatorMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ACX_SimulatorMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"Vel_Ref");
          _SFD_SET_DATA_PROPS(1,2,0,1,"Vel_Ref_Out");
          _SFD_SET_DATA_PROPS(2,1,1,0,"distanceToWPT");
          _SFD_SET_DATA_PROPS(3,1,1,0,"ThresholdDist");
          _SFD_SET_DATA_PROPS(4,1,1,0,"MaxDeltaVel");
          _SFD_SET_DATA_PROPS(5,1,1,0,"flagLastWPT");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,3,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,401);
        _SFD_CV_INIT_EML_IF(0,0,132,152,-1,397);
        _SFD_CV_INIT_EML_IF(0,1,154,186,-1,392);
        _SFD_CV_INIT_EML_IF(0,2,338,355,-1,388);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c55_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c55_sf_marshallOut,(MexInFcnForType)c55_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c55_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c55_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c55_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c55_sf_marshallOut,(MexInFcnForType)NULL);

        {
          real_T *c55_Vel_Ref;
          real_T *c55_Vel_Ref_Out;
          real_T *c55_distanceToWPT;
          real_T *c55_ThresholdDist;
          real_T *c55_MaxDeltaVel;
          real_T *c55_flagLastWPT;
          c55_flagLastWPT = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
          c55_MaxDeltaVel = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c55_ThresholdDist = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c55_distanceToWPT = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c55_Vel_Ref_Out = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c55_Vel_Ref = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c55_Vel_Ref);
          _SFD_SET_DATA_VALUE_PTR(1U, c55_Vel_Ref_Out);
          _SFD_SET_DATA_VALUE_PTR(2U, c55_distanceToWPT);
          _SFD_SET_DATA_VALUE_PTR(3U, c55_ThresholdDist);
          _SFD_SET_DATA_VALUE_PTR(4U, c55_MaxDeltaVel);
          _SFD_SET_DATA_VALUE_PTR(5U, c55_flagLastWPT);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ACX_SimulatorMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c55_ACX_Simulator(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc55_ACX_SimulatorInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c55_ACX_Simulator((SFc55_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
  initialize_c55_ACX_Simulator((SFc55_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c55_ACX_Simulator(void *chartInstanceVar)
{
  enable_c55_ACX_Simulator((SFc55_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c55_ACX_Simulator(void *chartInstanceVar)
{
  disable_c55_ACX_Simulator((SFc55_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c55_ACX_Simulator(void *chartInstanceVar)
{
  sf_c55_ACX_Simulator((SFc55_ACX_SimulatorInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c55_ACX_Simulator(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c55_ACX_Simulator
    ((SFc55_ACX_SimulatorInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c55_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c55_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c55_ACX_Simulator();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c55_ACX_Simulator((SFc55_ACX_SimulatorInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c55_ACX_Simulator(SimStruct* S)
{
  return sf_internal_get_sim_state_c55_ACX_Simulator(S);
}

static void sf_opaque_set_sim_state_c55_ACX_Simulator(SimStruct* S, const
  mxArray *st)
{
  sf_internal_set_sim_state_c55_ACX_Simulator(S, st);
}

static void sf_opaque_terminate_c55_ACX_Simulator(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc55_ACX_SimulatorInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c55_ACX_Simulator((SFc55_ACX_SimulatorInstanceStruct*)
      chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc55_ACX_Simulator((SFc55_ACX_SimulatorInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c55_ACX_Simulator(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c55_ACX_Simulator((SFc55_ACX_SimulatorInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c55_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,"ACX_Simulator","ACX_Simulator",55);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,"ACX_Simulator","ACX_Simulator",55,
                "RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,"ACX_Simulator",
      "ACX_Simulator",55,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"ACX_Simulator","ACX_Simulator",55,5);
      sf_mark_chart_reusable_outputs(S,"ACX_Simulator","ACX_Simulator",55,1);
    }

    sf_set_rtw_dwork_info(S,"ACX_Simulator","ACX_Simulator",55);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1599392431U));
  ssSetChecksum1(S,(1185281625U));
  ssSetChecksum2(S,(785024229U));
  ssSetChecksum3(S,(2631799451U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c55_ACX_Simulator(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "ACX_Simulator", "ACX_Simulator",55);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c55_ACX_Simulator(SimStruct *S)
{
  SFc55_ACX_SimulatorInstanceStruct *chartInstance;
  chartInstance = (SFc55_ACX_SimulatorInstanceStruct *)malloc(sizeof
    (SFc55_ACX_SimulatorInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc55_ACX_SimulatorInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c55_ACX_Simulator;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c55_ACX_Simulator;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c55_ACX_Simulator;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c55_ACX_Simulator;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c55_ACX_Simulator;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c55_ACX_Simulator;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c55_ACX_Simulator;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c55_ACX_Simulator;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c55_ACX_Simulator;
  chartInstance->chartInfo.mdlStart = mdlStart_c55_ACX_Simulator;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c55_ACX_Simulator;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c55_ACX_Simulator_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c55_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c55_ACX_Simulator(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c55_ACX_Simulator(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c55_ACX_Simulator_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
